/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is an optimized version of Dojo, built for deployment and not for
	development. To get sources and documentation, please visit:

		http://dojotoolkit.org
*/

if(!dojo._hasResource['epages.lang.color']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.lang.color'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.lang.color $Revision: 1.10 $

*/
dojo.provide('epages.lang.color');

epages.lang.color = {

	_hex:	function(c){
		c = parseInt(c).toString(16);
		return c.length < 2 ? "0" + c : c;
	},

	rgb2Hex: function(rgb){
		if (rgb.transparent == 1){
			return "transparent";
		}
		return '#' + this._hex(rgb.r) + this._hex(rgb.g) + this._hex(rgb.b);
	},

	hex2Rgb: function(hex) {
		if (hex == "transparent" || hex == "none"){
			return { r:255, g:255, b:255, transparent:1 };
		}
		hex = hex.toUpperCase();
		if(hex.charAt(0) == "#"){
			hex = hex.substring(1,hex.length);
		}
		if (hex.length == 6) {
			var rgb = {
				r: parseInt(hex.substring(0,2),16),
				g: parseInt(hex.substring(2,4),16),
				b: parseInt(hex.substring(4,6),16),
				transparent: 0
			};
		} else if (hex.length == 3) {
			var rgb = {
				r: parseInt(hex.substring(0,1) + hex.substring(0,1),16),
				g: parseInt(hex.substring(1,2) + hex.substring(1,2),16),
				b: parseInt(hex.substring(2,3) + hex.substring(2,3),16),
				transparent: 0
			};
		} else {
			//return white if no hex value was given
			var rgb = {
				r: 255,
				g: 255,
				b: 255,
				transparent: 0
			};
		}
		if(isNaN(rgb.r)){ rgb.r = 0; }
		if(isNaN(rgb.g)){ rgb.g = 0; }
		if(isNaN(rgb.b)){ rgb.b = 0; }

		return (rgb);
	},

	rgb2Hsb: function(rgb) {
		var min = new Number(Math.min(rgb.r, rgb.g));
		var max = new Number(Math.max(rgb.r, rgb.g));
		var sat = new Number(0);
		var lumin = new Number(0);
		min = Math.min(min, rgb.b);
		max = Math.max(max, rgb.b);
		var delta = (max - min);
		if (max != 0) {
			sat = delta / max;
			lumin = max / 255;
		}
		var hue = 0;
		if ( delta != 0 ) {
			if (rgb.r==max){
				hue = (rgb.g - rgb.b) / delta;
			}else if (rgb.g==max){
				hue = 2 + ((rgb.b - rgb.r) / delta);
			}else{
				hue = 4 + ((rgb.r - rgb.g) / delta);
			}
		}
		hue = (hue * 60);
		if (hue < 0){
			hue = hue + 360;
		}
		var tSat = (sat * 100);
		var tLum = (lumin * 100);

		return {s: Math.round(tSat), b: Math.round(tLum), h: Math.round(hue)};
	},

	hsb2Rgb: function(hsb) {
		var r = 0; var g = 0; var b = 0;
		var sat = hsb.s/100;
		var lum = hsb.b/100;
		//console.debug('sat ',sat,' lum ',lum,' hsb.h ',hsb.h);
		if (sat == 0) {
			r = lum;  g = r;  b = r;
		}
		else {
			var h = hsb.h/60;
			//if(h == 6) h = 0;
			var i = parseInt(h);
			var p = lum * (1.0 - sat);
			var q = lum * (1.0 - sat * (h - i));
			var t = lum * (1.0 - sat * (1- (h - i)));
			switch (i) {
				case 0: r = lum; g = t;   b = p;   break;
				case 1: r = q;   g = lum; b = p;   break;
				case 2: r = p;   g = lum; b = t;   break;
				case 3: r = p;   g = q;   b = lum; break;
				case 4: r = t;   g = p;   b = lum; break;
				case 5: r = lum; g = p;   b  = q;  break;
				case 6: r = lum; g = t;   b  = p;  break;
			}
		}
		return { r : (r*255), g : (g*255) , b : (b*255) };
	},

	cssString2Rgb: function(cssString) {
		return this.hex2Rgb(epages.validate.css.color2Hex(cssString));
	}

};

}

if(!dojo._hasResource['epages.validate.css']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.validate.css'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.validate.css $Revision: 1.21 $

*/
dojo.provide('epages.validate.css');




epages.validate.css.validColors = {
    'aliceblue': 'f0f8ff',
    'antiquewhite': 'faebd7',
    'aqua': '00ffff',
    'aquamarine': '7fffd4',
    'azure': 'f0ffff',
    'beige': 'f5f5dc',
    'bisque': 'ffe4c4',
    'black': '000000',
    'blanchedalmond': 'ffebcd',
    'blue': '0000ff',
    'blueviolet': '8a2be2',
    'brown': 'a52a2a',
    'burlywood': 'deb887',
    'cadetblue': '5f9ea0',
    'chartreuse': '7fff00',
    'chocolate': 'd2691e',
    'coral': 'ff7f50',
    'cornflowerblue': '6495ed',
    'cornsilk': 'fff8dc',
    'crimson': 'dc143c',
    'cyan': '00ffff',
    'darkblue': '00008b',
    'darkcyan': '008b8b',
    'darkgoldenrod': 'b8860b',
    'darkgray': 'a9a9a9',
    'darkgrey': 'a9a9a9',
    'darkgreen': '006400',
    'darkkhaki': 'bdb76b',
    'darkmagenta': '8b008b',
    'darkolivegreen': '556b2f',
    'darkorange': 'ff8c00',
    'darkorchid': '9932cc',
    'darkred': '8b0000',
    'darksalmon': 'e9967a',
    'darkseagreen': '8fbc8f',
    'darkslateblue': '483d8b',
    'darkslategray': '2f4f4f',
    'darkslategrey': '2f4f4f',
    'darkturquoise': '00ced1',
    'darkviolet': '9400d3',
    'deeppink': 'ff1493',
    'deepskyblue': '00bfff',
    'dimgray': '696969',
    'dimgrey': '696969',
    'dodgerblue': '1e90ff',
    'firebrick': 'b22222',
    'floralwhite': 'fffaf0',
    'forestgreen': '228b22',
    'fuchsia': 'ff00ff',
    'gainsboro': 'dcdcdc',
    'ghostwhite': 'f8f8ff',
    'gold': 'ffd700',
    'goldenrod': 'daa520',
    'gray': '808080',
    'grey': '808080',
    'green': '008000',
    'greenyellow': 'adff2f',
    'honeydew': 'f0fff0',
    'hotpink': 'ff69b4',
    'indianred': ':cd5c5c',
    'indigo': ':4b0082',
    'ivory': 'fffff0',
    'khaki': 'f0e68c',
    'lavender': 'e6e6fa',
    'lavenderblush': 'fff0f5',
    'lawngreen': '7cfc00',
    'lemonchiffon': 'fffacd',
    'lightblue': 'add8e6',
    'lightcoral': 'f08080',
    'lightcyan': 'e0ffff',
    'lightgoldenrodyellow': 'fafad2',
    'lightgray': 'd3d3d3',
    'lightgrey': 'd3d3d3',
    'lightgreen': '90ee90',
    'lightpink': 'ffb6c1',
    'lightsalmon': 'ffa07a',
    'lightseagreen': '20b2aa',
    'lightskyblue': '87cefa',
    'lightslategray': '778899',
    'lightslategrey': '778899',
    'lightsteelblue': 'b0c4de',
    'lightyellow': 'ffffe0',
    'lime': '00ff00',
    'limegreen': '32cd32',
    'linen': 'faf0e6',
    'magenta': 'ff00ff',
    'maroon': '800000',
    'mediumaquamarine': '66cdaa',
    'mediumblue': '0000cd',
    'mediumorchid': 'ba55d3',
    'mediumpurple': '9370d8',
    'mediumseagreen': '3cb371',
    'mediumslateblue': '7b68ee',
    'mediumspringgreen': '00fa9a',
    'mediumturquoise': '48d1cc',
    'mediumvioletred': 'c71585',
    'midnightblue': '191970',
    'mintcream': 'f5fffa',
    'mistyrose': 'ffe4e1',
    'moccasin': 'ffe4b5',
    'navajowhite': 'ffdead',
    'navy': '000080',
    'oldlace': 'fdf5e6',
    'olive': '808000',
    'olivedrab': '6b8e23',
    'orange': 'ffa500',
    'orangered': 'ff4500',
    'orchid': 'da70d6',
    'palegoldenrod': 'eee8aa',
    'palegreen': '98fb98',
    'paleturquoise': 'afeeee',
    'palevioletred': 'd87093',
    'papayawhip': 'ffefd5',
    'peachpuff': 'ffdab9',
    'peru': 'cd853f',
    'pink': 'ffc0cb',
    'plum': 'dda0dd',
    'powderblue': 'b0e0e6',
    'purple': '800080',
    'red': 'ff0000',
    'rosybrown': 'bc8f8f',
    'royalblue': '4169e1',
    'saddlebrown': '8b4513',
    'salmon': 'fa8072',
    'sandybrown': 'f4a460',
    'seagreen': '2e8b57',
    'seashell': 'fff5ee',
    'sienna': 'a0522d',
    'silver': 'c0c0c0',
    'skyblue': '87ceeb',
    'slateblue': '6a5acd',
    'slategray': '708090',
    'slategrey': '708090',
    'snow': 'fffafa',
    'springgreen': '00ff7f',
    'steelblue': '4682b4',
    'tan': 'd2b48c',
    'teal': '008080',
    'thistle': 'd8bfd8',
    'tomato': 'ff6347',
    'turquoise': '40e0d0',
    'violet': 'ee82ee',
    'wheat': 'f5deb3',
    'white': 'ffffff',
    'whitesmoke': 'f5f5f5',
    'yellow': 'ffff00',
    'yellowgreen': '9acd32'
};

epages.validate.css.color2Hex = function (value) {
    value = value.toLowerCase();
    var rx;
    if (value.match(/transparent/i)) {
        // transparent
        return "transparent";
    } else if (value.match(/^\s*$|none/i)) {
        //none
        return "none";
    } else if (value.match(/^#[0-9A-F]{6}$/i)) {
        // 6 digit hex rgb value (#1234FF or 1234FF)
        return value.toLowerCase();
    } else if (epages.validate.css.validColors[value] !== undefined) {
        // known color name
        return '#' + epages.validate.css.validColors[value];
    } else if (rx = value.match(/^#([0-9A-F])([0-9A-F])([0-9A-F])$/i)) {
        // 3 digit hex rgb value (#123 or #FFF)
        return ("#" + rx[1] + rx[1] + rx[2] + rx[2] + rx[3] + rx[3]).toLowerCase();
    } else if (rx = value.match(/^rgb\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*\)$/i)) {
        // rgb values - pattern: "rgb(123,234,1)"
        return epages.lang.color.rgb2Hex({
            r: rx[1],
            g: rx[2],
            b: rx[3]
        }).toLowerCase();
    } else {
        return false;
    }
};

epages.validate.css.isColor = function (value) {
    return epages.validate.css.color2Hex(value) !== false;
};

epages.validate.css.isSize = function (value, settings, negativAllowed) {
    nbr_value = epages.string.cssSizeToNumber(value);
    if (nbr_value !== NaN && settings !== undefined) {
        if (settings.min && settings.max && (nbr_value < settings.min || nbr_value > settings.max)) {
            return 'NOT_IN_RANGE';
        }

        if (settings.min != null && nbr_value < settings.min) {
            return 'LOWER_THAN_MIN';
        }
        if (settings.max != null && nbr_value > settings.max) {
            return 'GREATER_THAN_MAX';
        }
    }

    var getExp = function (exp) {
        return new RegExp('^(' + (settings.autoAllowed ? 'auto|' : '') + (settings.negativeAllowed ? '-?' : '') + exp + ')$', 'i');
    };

    if (value.match(getExp('[0-9]+(px|pt)'))) {
        return true;
    }
    if (value.match(getExp('[0-9]*\.?[0-9]+(pc|%|mm|cm|em|in|ex)'))) {
        return true;
    }
    if (value.match(getExp('[0]+'))) {
        return true;
    }

    // comment.translate:NO_UNIT_VALUE,NO_UNIT,NO_NUMBER,FLOAT_NOT_ALLOWED,UNKNOWN_UNIT,UNKNOWN_ERROR
    if (value == "") {
        return 'NO_UNIT_VALUE';
    }
    if (value.match(getExp('[0-9]+'))) {
        return 'NO_UNIT';
    }
    if (!value.match(getExp('[0-9]*\.?[0-9]'))) {
        return 'NO_NUMBER';
    }
    if (value.match(getExp('[0-9]*\.[0-9]+(?:px|pt)'))) {
        return 'FLOAT_NOT_ALLOWED';
    }
    if (value.match(getExp('[0-9]*\.[0-9]'))) {
        return 'NO_UNIT';
    }
    if (value.match(getExp('[0-9]*\.?[0-9]+[a-z]+'))) {
        return 'UNKNOWN_UNIT';
    }
    return 'UNKNOWN_ERROR';
};

epages.validate.css.isWidth = epages.validate.css.isSize;
epages.validate.css.isHeight = epages.validate.css.isSize;
epages.validate.css.isPadding = epages.validate.css.isSize;
epages.validate.css.isMargin = epages.validate.css.isSize;

}

if(!dojo._hasResource['epages.validate.number']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.validate.number'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.validate.number $Revision: 1.7 $

*/
dojo.provide('epages.validate.number');

epages.validate.number.isInteger = function(value, settings) {
  if (settings == null){
    settings = {};
  }
  // convert to string
  value += '';

	// comment.translate:NO_VALUE,NO_INTEGER,NOT_IN_RANGE,LOWER_THAN_MIN,GREATER_THAN_MAX
  if (value == ''){
  	return 'NO_VALUE';
  }
  if (!(/^(?:0|-?[1-9][0-9]*)$/).test(value)){
  	return 'NO_INTEGER';
 	}
  value = Number(value);
  if ((settings.min != null && value < settings.min) ||
      (settings.max != null && value > settings.max)){
      	return 'NOT_IN_RANGE';
  }
  if (settings.min != null && value < settings.min){
  	return 'LOWER_THAN_MIN';
  }
  if (settings.max != null && value > settings.max){
  	return 'GREATER_THAN_MAX';
  }
  return true;
};

}

if(!dojo._hasResource['epages.validate.string']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.validate.string'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.validate.string $Revision: 1.4 $

*/
dojo.provide('epages.validate.string');

epages.validate.string.isXMLAttribute = function(attributeName) {
	if (attributeName == ''){
		return false;
	}

	// reference http://www.w3.org/TR/REC-xml/#NT-Name
	var XML_SYNTAX_BaseChar      = "[\u0041-\u005A\u0061-\u007A\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u00FF\u0100-\u0131\u0134-\u013E\u0141-\u0148\u014A-\u017E\u0180-\u01C3\u01CD-\u01F0\u01F4-\u01F5\u01FA-\u0217\u0250-\u02A8\u02BB-\u02C1\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03CE\u03D0-\u03D6\u03DA\u03DC\u03DE\u03E0\u03E2-\u03F3\u0401-\u040C\u040E-\u044F\u0451-\u045C\u045E-\u0481\u0490-\u04C4\u04C7-\u04C8\u04CB-\u04CC\u04D0-\u04EB\u04EE-\u04F5\u04F8-\u04F9\u0531-\u0556\u0559\u0561-\u0586\u05D0-\u05EA\u05F0-\u05F2\u0621-\u063A\u0641-\u064A\u0671-\u06B7\u06BA-\u06BE\u06C0-\u06CE\u06D0-\u06D3\u06D5\u06E5-\u06E6\u0905-\u0939\u093D\u0958-\u0961\u0985-\u098C\u098F-\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09DC-\u09DD\u09DF-\u09E1\u09F0-\u09F1\u0A05-\u0A0A\u0A0F-\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32-\u0A33\u0A35-\u0A36\u0A38-\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8B\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2-\u0AB3\u0AB5-\u0AB9\u0ABD\u0AE0\u0B05-\u0B0C\u0B0F-\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32-\u0B33\u0B36-\u0B39\u0B3D\u0B5C-\u0B5D\u0B5F-\u0B61\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99-\u0B9A\u0B9C\u0B9E-\u0B9F\u0BA3-\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB5\u0BB7-\u0BB9\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C60-\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CDE\u0CE0-\u0CE1\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D28\u0D2A-\u0D39\u0D60-\u0D61\u0E01-\u0E2E\u0E30\u0E32-\u0E33\u0E40-\u0E45\u0E81-\u0E82\u0E84\u0E87-\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA-\u0EAB\u0EAD-\u0EAE\u0EB0\u0EB2-\u0EB3\u0EBD\u0EC0-\u0EC4\u0F40-\u0F47\u0F49-\u0F69\u10A0-\u10C5\u10D0-\u10F6\u1100\u1102-\u1103\u1105-\u1107\u1109\u110B-\u110C\u110E-\u1112\u113C\u113E\u1140\u114C\u114E\u1150\u1154-\u1155\u1159\u115F-\u1161\u1163\u1165\u1167\u1169\u116D-\u116E\u1172-\u1173\u1175\u119E\u11A8\u11AB\u11AE-\u11AF\u11B7-\u11B8\u11BA\u11BC-\u11C2\u11EB\u11F0\u11F9\u1E00-\u1E9B\u1EA0-\u1EF9\u1F00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2126\u212A-\u212B\u212E\u2180-\u2182\u3041-\u3094\u30A1-\u30FA\u3105-\u312C\uAC00-\uD7A3]";
	var XML_SYNTAX_Ideographic   = "[\u4E00-\u9FA5\u3007\u3021-\u3029]";
	var XML_SYNTAX_CombiningChar = "[\u0300-\u0345\u0360-\u0361\u0483-\u0486\u0591-\u05A1\u05A3-\u05B9\u05BB-\u05BD\u05BF\u05C1-\u05C2\u05C4\u064B-\u0652\u0670\u06D6-\u06DC\u06DD-\u06DF\u06E0-\u06E4\u06E7-\u06E8\u06EA-\u06ED\u0901-\u0903\u093C\u093E-\u094C\u094D\u0951-\u0954\u0962-\u0963\u0981-\u0983\u09BC\u09BE\u09BF\u09C0-\u09C4\u09C7-\u09C8\u09CB-\u09CD\u09D7\u09E2-\u09E3\u0A02\u0A3C\u0A3E\u0A3F\u0A40-\u0A42\u0A47-\u0A48\u0A4B-\u0A4D\u0A70-\u0A71\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0B01-\u0B03\u0B3C\u0B3E-\u0B43\u0B47-\u0B48\u0B4B-\u0B4D\u0B56-\u0B57\u0B82-\u0B83\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0C01-\u0C03\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55-\u0C56\u0C82-\u0C83\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5-\u0CD6\u0D02-\u0D03\u0D3E-\u0D43\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0EB1\u0EB4-\u0EB9\u0EBB-\u0EBC\u0EC8-\u0ECD\u0F18-\u0F19\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86-\u0F8B\u0F90-\u0F95\u0F97\u0F99-\u0FAD\u0FB1-\u0FB7\u0FB9\u20D0-\u20DC\u20E1\u302A-\u302F\u3099\u309A]";
	var XML_SYNTAX_Digit         = "[\u0030-\u0039\u0660-\u0669\u06F0-\u06F9\u0966-\u096F\u09E6-\u09EF\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0BE7-\u0BEF\u0C66-\u0C6F\u0CE6-\u0CEF\u0D66-\u0D6F\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F29]";
	var XML_SYNTAX_Extender      = "[\u00B7\u02D0\u02D1\u0387\u0640\u0E46\u0EC6\u3005\u3031-\u3035\u309D-\u309E\u30FC-\u30FE]";
	var XML_SYNTAX_Letter        = XML_SYNTAX_BaseChar + "|" + XML_SYNTAX_Ideographic;
	var XML_SYNTAX_NameChar      = XML_SYNTAX_Letter + "|" + XML_SYNTAX_Digit + "|[-._:]|" + XML_SYNTAX_CombiningChar + "|" + XML_SYNTAX_Extender;
	var XML_SYNTAX_Name          = "^(" + XML_SYNTAX_Letter + "|[_:])" + "(" + XML_SYNTAX_NameChar + ")*$";

	return attributeName.match( new RegExp( XML_SYNTAX_Name ) ) ? true : false;
};
epages.validate.string.filterInvalidChars = function(/*string*/ insertString){
	// summary: removes invalid chars from given string
   // description: function removes invalid chars or combination of chars from given string
   // remove all backslashes can cause errors on the server
   // example:
   //    var result = epages.validate.string.filterInvalidChars('Affe/\Ente');
   // returns:  Affe/Ente
	var regExpString = /%5C/gi;
	insertString = encodeURIComponent(insertString);
	var returnString = insertString.replace(regExpString,'');
	returnString = decodeURIComponent(returnString);
	return returnString;
};

}

if(!dojo._hasResource["epages.widget.Validateinput"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Validateinput"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.
*/
dojo.provide("epages.widget.Validateinput");









(function(dj){

	var handleID = 0;
	
	var _validateInput = {
		/**
		* public properties
		*/
		validationType  : "",
		errorBox        : null,
		inputError      : false,
		undoWidgetId    : 'undoWidget',
		dictionary      : epages.io.dictionary,
		allowEmpty      : '0',
		/**
		 * settings: String 
		 * comma seperated parameters will be passed to the validate function
		 * as hash object (processed from string e.g. settings="min:10,max:100" becomes
		 * { min: 10, max: 100 } [Object])
		 */
		settings        : '',

		postCreate: function() {
			this.validationType = this.domNode.getAttribute('validationType') || this.validationType;
			this.undoWidgetId   = this.domNode.getAttribute('undoWidgetId') || this.undoWidgetId;
			this.settings       = this.domNode.getAttribute('settings') || this.settings;
			this.allowEmpty     = this.domNode.getAttribute('allowEmpty') || this.allowEmpty;
		
			//this.inherited("postCreate", arguments);
			this.allowEmpty = epages.string.toBoolean(this.allowEmpty);

			dojo.addOnLoad(this, "_appendEvent");

			//create Error-Attribute
			var atr = document.createAttribute("ep_error");
			atr.nodeValue = "0";
			this.domNode.setAttributeNode(atr);
			if (dojo.isString(this.settings) && this.settings.length > 0) {
			  this.settings = dojo.fromJson('{' + this.settings + '}');
			}
		},
		
		connect: function( node, event, fn ){
			handleID++;
			this.addHandle( 'validateInput.handle_'+handleID , node, event, fn );
			this.connectHandle( 'validateInput.handle_'+handleID );
		},

		_appendEvent: function() {
			if(this.validationType != "") {
				this.connect(this.domNode, 'onkeyup', '_keyupValidation');
				this.connect(this.domNode, 'onclick', '_keyupValidation');
				this.connect(this.domNode, 'onchange', '_onChange');
				this.connect(this.domNode, 'onkeyup', '_onChange');
				this.connect(this.domNode, 'onclick', '_onChange');
			}
		},

		_validate: function() {
			var value = this.domNode.value;
			if (value !== undefined) {
  			if (this.allowEmpty && value == ''){
  				return true;
  			}
				switch (this.validationType.toLowerCase()) {
					case 'integer':
						var result = epages.validate.number.isInteger(value, this.settings);
						break;
					case 'size':
						var result = epages.validate.css.isSize(value, this.settings);
						break;
					case 'color':
						// comment.translate:NO_COLOR_VALUE
						var result = epages.validate.css.isColor(value, this.settings) ? true : "NO_COLOR_VALUE";
						break;
					case 'date':
						var result = epages.validate.date.isDate(value, this.settings);
						break;
					case 'time':
						var result = epages.validate.date.isTime(value, this.settings);
						break;
					case 'datetime':
						var result = epages.validate.date.isDateTime(value, this.settings);
						break;
					default:
						console.warn("Unknown validationType " + this.validationType + " for widget " + this.id);
						break;
				}
				return result;
			}
		},

		_keyupValidation: function() {
			var result = this._validate();
			if(result == true){
				//remove Error
				this._removeError();
			} else {
				//add Css-Error-Class
				this._setError();
			}

			if (this.undoWidgetId !== undefined) {
				if ($$(this.undoWidgetId) !== undefined) {
					$$(this.undoWidgetId).undoObject.validateInput(this.domNode);
				} else {
					console.warn('undoWidget "' + this.undoWidgetId + '" does not exist. ('+this.declaredClass+')');
					this.undoWidgetId = undefined;
				}
			}
		},

		_setError: function() {
			dojo.addClass(this.domNode, "DialogError");
			//set Error-Attribute
			this.domNode.setAttribute("ep_error", "1");
			dojo.publish(this.id+'/Error',[{ id: this.id, errorState: true }]);
		},

		_removeError: function() {
			dojo.removeClass(this.domNode, "DialogError");
			//remove Error-Box
			if(this.domNode.getAttribute("ep_error") == "1") {
				dojo.publish("uimessage/hide", []);
			}
			//reset Error-Attribute
			this.domNode.setAttribute("ep_error", "0");
			dojo.publish(this.id+'/Error',[{ id: this.id, errorState: false }]);
		},

		_onChange: function() {
			//set 'px' as default-unit
			var result = this._validate();
			if (result != true) {
				//display Error-Box-Widget
				var position = $E(this.domNode).getAbsolutePosition();

				dojo.publish("uimessage/show", ["", this.dictionary.get(result, this.settings), "Bubble", {
					typeClass: "Warning",
					sizeClass: "Small",
					x: position.x,
					y: (position.y + this.domNode.clientHeight + 4)
				}]);
			}
			else {
				//hide Error-Box
				// dojo.publish("uimessage/hide", []);
			}
			this._keyupValidation();
		}
	};

	epages.widget.Validateinput = function( options, domNode ){
		this.destroy();
		
		var widget = new epages.widget.FormText( options, domNode );
		
			widget = dj.mixin( widget, _validateInput );
			
			widget.postCreate();

		return widget;
	};
	epages.widget.Validateinput.prototype = new dijit._Widget();

})(dojo);


}

if(!dojo._hasResource["dojo.dnd.Selector"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.Selector"] = true;
dojo.provide("dojo.dnd.Selector");




/*
	Container item states:
		""			- an item is not selected
		"Selected"	- an item is selected
		"Anchor"	- an item is selected, and is an anchor for a "shift" selection
*/

/*=====
dojo.declare("dojo.dnd.__SelectorArgs", [dojo.dnd.__ContainerArgs], {
	//	singular: Boolean
	//		allows selection of only one element, if true
	singular: false,

	//	autoSync: Boolean
	//		autosynchronizes the source with its list of DnD nodes,
	autoSync: false
});
=====*/

dojo.declare("dojo.dnd.Selector", dojo.dnd.Container, {
	// summary:
	//		a Selector object, which knows how to select its children
	
	/*=====
	// selection: Set<String>
	//		The set of id's that are currently selected, such that this.selection[id] == 1
	//		if the node w/that id is selected.  Can iterate over selected node's id's like:
	//	|		for(var id in this.selection)
	selection: {},
	=====*/

	constructor: function(node, params){
		// summary:
		//		constructor of the Selector
		// node: Node||String
		//		node or node's id to build the selector on
		// params: dojo.dnd.__SelectorArgs?
		//		a dictionary of parameters
		if(!params){ params = {}; }
		this.singular = params.singular;
		this.autoSync = params.autoSync;
		// class-specific variables
		this.selection = {};
		this.anchor = null;
		this.simpleSelection = false;
		// set up events
		this.events.push(
			dojo.connect(this.node, "onmousedown", this, "onMouseDown"),
			dojo.connect(this.node, "onmouseup",   this, "onMouseUp"));
	},
	
	// object attributes (for markup)
	singular: false,	// is singular property
	
	// methods
	getSelectedNodes: function(){
		// summary:
		//		returns a list (an array) of selected nodes
		var t = new dojo.NodeList();
		var e = dojo.dnd._empty;
		for(var i in this.selection){
			if(i in e){ continue; }
			t.push(dojo.byId(i));
		}
		return t;	// NodeList
	},
	selectNone: function(){
		// summary:
		//		unselects all items
		return this._removeSelection()._removeAnchor();	// self
	},
	selectAll: function(){
		// summary:
		//		selects all items
		this.forInItems(function(data, id){
			this._addItemClass(dojo.byId(id), "Selected");
			this.selection[id] = 1;
		}, this);
		return this._removeAnchor();	// self
	},
	deleteSelectedNodes: function(){
		// summary:
		//		deletes all selected items
		var e = dojo.dnd._empty;
		for(var i in this.selection){
			if(i in e){ continue; }
			var n = dojo.byId(i);
			this.delItem(i);
			dojo.destroy(n);
		}
		this.anchor = null;
		this.selection = {};
		return this;	// self
	},
	forInSelectedItems: function(/*Function*/ f, /*Object?*/ o){
		// summary:
		//		iterates over selected items;
		//		see `dojo.dnd.Container.forInItems()` for details
		o = o || dojo.global;
		var s = this.selection, e = dojo.dnd._empty;
		for(var i in s){
			if(i in e){ continue; }
			f.call(o, this.getItem(i), i, this);
		}
	},
	sync: function(){
		// summary:
		//		sync up the node list with the data map
		
		dojo.dnd.Selector.superclass.sync.call(this);
		
		// fix the anchor
		if(this.anchor){
			if(!this.getItem(this.anchor.id)){
				this.anchor = null;
			}
		}
		
		// fix the selection
		var t = [], e = dojo.dnd._empty;
		for(var i in this.selection){
			if(i in e){ continue; }
			if(!this.getItem(i)){
				t.push(i);
			}
		}
		dojo.forEach(t, function(i){
			delete this.selection[i];
		}, this);
		
		return this;	// self
	},
	insertNodes: function(addSelected, data, before, anchor){
		// summary:
		//		inserts new data items (see `dojo.dnd.Container.insertNodes()` method for details)
		// addSelected: Boolean
		//		all new nodes will be added to selected items, if true, no selection change otherwise
		// data: Array
		//		a list of data items, which should be processed by the creator function
		// before: Boolean
		//		insert before the anchor, if true, and after the anchor otherwise
		// anchor: Node
		//		the anchor node to be used as a point of insertion
		var oldCreator = this._normalizedCreator;
		this._normalizedCreator = function(item, hint){
			var t = oldCreator.call(this, item, hint);
			if(addSelected){
				if(!this.anchor){
					this.anchor = t.node;
					this._removeItemClass(t.node, "Selected");
					this._addItemClass(this.anchor, "Anchor");
				}else if(this.anchor != t.node){
					this._removeItemClass(t.node, "Anchor");
					this._addItemClass(t.node, "Selected");
				}
				this.selection[t.node.id] = 1;
			}else{
				this._removeItemClass(t.node, "Selected");
				this._removeItemClass(t.node, "Anchor");
			}
			return t;
		};
		dojo.dnd.Selector.superclass.insertNodes.call(this, data, before, anchor);
		this._normalizedCreator = oldCreator;
		return this;	// self
	},
	destroy: function(){
		// summary:
		//		prepares the object to be garbage-collected
		dojo.dnd.Selector.superclass.destroy.call(this);
		this.selection = this.anchor = null;
	},

	// markup methods
	markupFactory: function(params, node){
		params._skipStartup = true;
		return new dojo.dnd.Selector(node, params);
	},

	// mouse events
	onMouseDown: function(e){
		// summary:
		//		event processor for onmousedown
		// e: Event
		//		mouse event
		if(this.autoSync){ this.sync(); }
		if(!this.current){ return; }
		if(!this.singular && !dojo.isCopyKey(e) && !e.shiftKey && (this.current.id in this.selection)){
			this.simpleSelection = true;
			if(e.button === dojo.mouseButtons.LEFT){
				// accept the left button and stop the event
				// for IE we don't stop event when multiple buttons are pressed
				dojo.stopEvent(e);
			}
			return;
		}
		if(!this.singular && e.shiftKey){
			if(!dojo.isCopyKey(e)){
				this._removeSelection();
			}
			var c = this.getAllNodes();
			if(c.length){
				if(!this.anchor){
					this.anchor = c[0];
					this._addItemClass(this.anchor, "Anchor");
				}
				this.selection[this.anchor.id] = 1;
				if(this.anchor != this.current){
					var i = 0;
					for(; i < c.length; ++i){
						var node = c[i];
						if(node == this.anchor || node == this.current){ break; }
					}
					for(++i; i < c.length; ++i){
						var node = c[i];
						if(node == this.anchor || node == this.current){ break; }
						this._addItemClass(node, "Selected");
						this.selection[node.id] = 1;
					}
					this._addItemClass(this.current, "Selected");
					this.selection[this.current.id] = 1;
				}
			}
		}else{
			if(this.singular){
				if(this.anchor == this.current){
					if(dojo.isCopyKey(e)){
						this.selectNone();
					}
				}else{
					this.selectNone();
					this.anchor = this.current;
					this._addItemClass(this.anchor, "Anchor");
					this.selection[this.current.id] = 1;
				}
			}else{
				if(dojo.isCopyKey(e)){
					if(this.anchor == this.current){
						delete this.selection[this.anchor.id];
						this._removeAnchor();
					}else{
						if(this.current.id in this.selection){
							this._removeItemClass(this.current, "Selected");
							delete this.selection[this.current.id];
						}else{
							if(this.anchor){
								this._removeItemClass(this.anchor, "Anchor");
								this._addItemClass(this.anchor, "Selected");
							}
							this.anchor = this.current;
							this._addItemClass(this.current, "Anchor");
							this.selection[this.current.id] = 1;
						}
					}
				}else{
					if(!(this.current.id in this.selection)){
						this.selectNone();
						this.anchor = this.current;
						this._addItemClass(this.current, "Anchor");
						this.selection[this.current.id] = 1;
					}
				}
			}
		}
		dojo.stopEvent(e);
	},
	onMouseUp: function(e){
		// summary:
		//		event processor for onmouseup
		// e: Event
		//		mouse event
		if(!this.simpleSelection){ return; }
		this.simpleSelection = false;
		this.selectNone();
		if(this.current){
			this.anchor = this.current;
			this._addItemClass(this.anchor, "Anchor");
			this.selection[this.current.id] = 1;
		}
	},
	onMouseMove: function(e){
		// summary
		//		event processor for onmousemove
		// e: Event
		//		mouse event
		this.simpleSelection = false;
	},
	
	// utilities
	onOverEvent: function(){
		// summary:
		//		this function is called once, when mouse is over our container
		this.onmousemoveEvent = dojo.connect(this.node, "onmousemove", this, "onMouseMove");
	},
	onOutEvent: function(){
		// summary:
		//		this function is called once, when mouse is out of our container
		dojo.disconnect(this.onmousemoveEvent);
		delete this.onmousemoveEvent;
	},
	_removeSelection: function(){
		// summary:
		//		unselects all items
		var e = dojo.dnd._empty;
		for(var i in this.selection){
			if(i in e){ continue; }
			var node = dojo.byId(i);
			if(node){ this._removeItemClass(node, "Selected"); }
		}
		this.selection = {};
		return this;	// self
	},
	_removeAnchor: function(){
		if(this.anchor){
			this._removeItemClass(this.anchor, "Anchor");
			this.anchor = null;
		}
		return this;	// self
	}
});

}

if(!dojo._hasResource["dojo.dnd.Avatar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.Avatar"] = true;
dojo.provide("dojo.dnd.Avatar");



dojo.declare("dojo.dnd.Avatar", null, {
	// summary:
	//		Object that represents transferred DnD items visually
	// manager: Object
	//		a DnD manager object

	constructor: function(manager){
		this.manager = manager;
		this.construct();
	},

	// methods
	construct: function(){
		// summary:
		//		constructor function;
		//		it is separate so it can be (dynamically) overwritten in case of need
		this.isA11y = dojo.hasClass(dojo.body(),"dijit_a11y");
		var a = dojo.create("table", {
				"class": "dojoDndAvatar",
				style: {
					position: "absolute",
					zIndex:   "1999",
					margin:   "0px"
				}
			}),
			source = this.manager.source, node,
			b = dojo.create("tbody", null, a),
			tr = dojo.create("tr", null, b),
			td = dojo.create("td", null, tr),
			icon = this.isA11y ? dojo.create("span", {
						id : "a11yIcon",
						innerHTML : this.manager.copy ? '+' : "<"
					}, td) : null,
			span = dojo.create("span", {
				innerHTML: source.generateText ? this._generateText() : ""
			}, td),
			k = Math.min(5, this.manager.nodes.length), i = 0;
		// we have to set the opacity on IE only after the node is live
		dojo.attr(tr, {
			"class": "dojoDndAvatarHeader",
			style: {opacity: 0.9}
		});
		for(; i < k; ++i){
			if(source.creator){
				// create an avatar representation of the node
				node = source._normalizedCreator(source.getItem(this.manager.nodes[i].id).data, "avatar").node;
			}else{
				// or just clone the node and hope it works
				node = this.manager.nodes[i].cloneNode(true);
				if(node.tagName.toLowerCase() == "tr"){
					// insert extra table nodes
					var table = dojo.create("table"),
						tbody = dojo.create("tbody", null, table);
					tbody.appendChild(node);
					node = table;
				}
			}
			node.id = "";
			tr = dojo.create("tr", null, b);
			td = dojo.create("td", null, tr);
			td.appendChild(node);
			dojo.attr(tr, {
				"class": "dojoDndAvatarItem",
				style: {opacity: (9 - i) / 10}
			});
		}
		this.node = a;
	},
	destroy: function(){
		// summary:
		//		destructor for the avatar; called to remove all references so it can be garbage-collected
		dojo.destroy(this.node);
		this.node = false;
	},
	update: function(){
		// summary:
		//		updates the avatar to reflect the current DnD state
		dojo[(this.manager.canDropFlag ? "add" : "remove") + "Class"](this.node, "dojoDndAvatarCanDrop");
		if (this.isA11y){
			var icon = dojo.byId("a11yIcon");
			var text = '+';   // assume canDrop && copy
			if (this.manager.canDropFlag && !this.manager.copy) {
				text = '< '; // canDrop && move
			}else if (!this.manager.canDropFlag && !this.manager.copy) {
				text = "o"; //!canDrop && move
			}else if(!this.manager.canDropFlag){
				text = 'x';  // !canDrop && copy
			}
			icon.innerHTML=text;
		}
		// replace text
		dojo.query(("tr.dojoDndAvatarHeader td span" +(this.isA11y ? " span" : "")), this.node).forEach(
			function(node){
				node.innerHTML = this._generateText();
			}, this);
	},
	_generateText: function(){
		// summary: generates a proper text to reflect copying or moving of items
		return this.manager.nodes.length.toString();
	}
});

}

if(!dojo._hasResource["dojo.dnd.Manager"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.Manager"] = true;
dojo.provide("dojo.dnd.Manager");





dojo.declare("dojo.dnd.Manager", null, {
	// summary:
	//		the manager of DnD operations (usually a singleton)
	constructor: function(){
		this.avatar  = null;
		this.source = null;
		this.nodes = [];
		this.copy  = true;
		this.target = null;
		this.canDropFlag = false;
		this.events = [];
	},

	// avatar's offset from the mouse
	OFFSET_X: 16,
	OFFSET_Y: 16,
	
	// methods
	overSource: function(source){
		// summary:
		//		called when a source detected a mouse-over condition
		// source: Object
		//		the reporter
		if(this.avatar){
			this.target = (source && source.targetState != "Disabled") ? source : null;
			this.canDropFlag = Boolean(this.target);
			this.avatar.update();
		}
		dojo.publish("/dnd/source/over", [source]);
	},
	outSource: function(source){
		// summary:
		//		called when a source detected a mouse-out condition
		// source: Object
		//		the reporter
		if(this.avatar){
			if(this.target == source){
				this.target = null;
				this.canDropFlag = false;
				this.avatar.update();
				dojo.publish("/dnd/source/over", [null]);
			}
		}else{
			dojo.publish("/dnd/source/over", [null]);
		}
	},
	startDrag: function(source, nodes, copy){
		// summary:
		//		called to initiate the DnD operation
		// source: Object
		//		the source which provides items
		// nodes: Array
		//		the list of transferred items
		// copy: Boolean
		//		copy items, if true, move items otherwise
		this.source = source;
		this.nodes  = nodes;
		this.copy   = Boolean(copy); // normalizing to true boolean
		this.avatar = this.makeAvatar();
		dojo.body().appendChild(this.avatar.node);
		dojo.publish("/dnd/start", [source, nodes, this.copy]);
		this.events = [
			dojo.connect(dojo.doc, "onmousemove", this, "onMouseMove"),
			dojo.connect(dojo.doc, "onmouseup",   this, "onMouseUp"),
			dojo.connect(dojo.doc, "onkeydown",   this, "onKeyDown"),
			dojo.connect(dojo.doc, "onkeyup",     this, "onKeyUp"),
			// cancel text selection and text dragging
			dojo.connect(dojo.doc, "ondragstart",   dojo.stopEvent),
			dojo.connect(dojo.body(), "onselectstart", dojo.stopEvent)
		];
		var c = "dojoDnd" + (copy ? "Copy" : "Move");
		dojo.addClass(dojo.body(), c);
	},
	canDrop: function(flag){
		// summary:
		//		called to notify if the current target can accept items
		var canDropFlag = Boolean(this.target && flag);
		if(this.canDropFlag != canDropFlag){
			this.canDropFlag = canDropFlag;
			this.avatar.update();
		}
	},
	stopDrag: function(){
		// summary:
		//		stop the DnD in progress
		dojo.removeClass(dojo.body(), ["dojoDndCopy", "dojoDndMove"]);
		dojo.forEach(this.events, dojo.disconnect);
		this.events = [];
		this.avatar.destroy();
		this.avatar = null;
		this.source = this.target = null;
		this.nodes = [];
	},
	makeAvatar: function(){
		// summary:
		//		makes the avatar; it is separate to be overwritten dynamically, if needed
		return new dojo.dnd.Avatar(this);
	},
	updateAvatar: function(){
		// summary:
		//		updates the avatar; it is separate to be overwritten dynamically, if needed
		this.avatar.update();
	},
	
	// mouse event processors
	onMouseMove: function(e){
		// summary:
		//		event processor for onmousemove
		// e: Event
		//		mouse event
		var a = this.avatar;
		if(a){
			dojo.dnd.autoScrollNodes(e);
			//dojo.dnd.autoScroll(e);
			var s = a.node.style;
			s.left = (e.pageX + this.OFFSET_X) + "px";
			s.top  = (e.pageY + this.OFFSET_Y) + "px";
			var copy = Boolean(this.source.copyState(dojo.isCopyKey(e)));
			if(this.copy != copy){
				this._setCopyStatus(copy);
			}
		}
	},
	onMouseUp: function(e){
		// summary:
		//		event processor for onmouseup
		// e: Event
		//		mouse event
		if(this.avatar){
			if(this.target && this.canDropFlag){
				var copy = Boolean(this.source.copyState(dojo.isCopyKey(e))),
				params = [this.source, this.nodes, copy, this.target, e];
				dojo.publish("/dnd/drop/before", params);
				dojo.publish("/dnd/drop", params);
			}else{
				dojo.publish("/dnd/cancel");
			}
			this.stopDrag();
		}
	},
	
	// keyboard event processors
	onKeyDown: function(e){
		// summary:
		//		event processor for onkeydown:
		//		watching for CTRL for copy/move status, watching for ESCAPE to cancel the drag
		// e: Event
		//		keyboard event
		if(this.avatar){
			switch(e.keyCode){
				case dojo.keys.CTRL:
					var copy = Boolean(this.source.copyState(true));
					if(this.copy != copy){
						this._setCopyStatus(copy);
					}
					break;
				case dojo.keys.ESCAPE:
					dojo.publish("/dnd/cancel");
					this.stopDrag();
					break;
			}
		}
	},
	onKeyUp: function(e){
		// summary:
		//		event processor for onkeyup, watching for CTRL for copy/move status
		// e: Event
		//		keyboard event
		if(this.avatar && e.keyCode == dojo.keys.CTRL){
			var copy = Boolean(this.source.copyState(false));
			if(this.copy != copy){
				this._setCopyStatus(copy);
			}
		}
	},
	
	// utilities
	_setCopyStatus: function(copy){
		// summary:
		//		changes the copy status
		// copy: Boolean
		//		the copy status
		this.copy = copy;
		this.source._markDndStatus(this.copy);
		this.updateAvatar();
		dojo.replaceClass(dojo.body(),
			"dojoDnd" + (this.copy ? "Copy" : "Move"),
			"dojoDnd" + (this.copy ? "Move" : "Copy"));
	}
});

// dojo.dnd._manager:
//		The manager singleton variable. Can be overwritten if needed.
dojo.dnd._manager = null;

dojo.dnd.manager = function(){
	// summary:
	//		Returns the current DnD manager.  Creates one if it is not created yet.
	if(!dojo.dnd._manager){
		dojo.dnd._manager = new dojo.dnd.Manager();
	}
	return dojo.dnd._manager;	// Object
};

}

if(!dojo._hasResource["dojo.dnd.Source"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.Source"] = true;
dojo.provide("dojo.dnd.Source");




/*
	Container property:
		"Horizontal"- if this is the horizontal container
	Source states:
		""			- normal state
		"Moved"		- this source is being moved
		"Copied"	- this source is being copied
	Target states:
		""			- normal state
		"Disabled"	- the target cannot accept an avatar
	Target anchor state:
		""			- item is not selected
		"Before"	- insert point is before the anchor
		"After"		- insert point is after the anchor
*/

/*=====
dojo.dnd.__SourceArgs = function(){
	//	summary:
	//		a dict of parameters for DnD Source configuration. Note that any
	//		property on Source elements may be configured, but this is the
	//		short-list
	//	isSource: Boolean?
	//		can be used as a DnD source. Defaults to true.
	//	accept: Array?
	//		list of accepted types (text strings) for a target; defaults to
	//		["text"]
	//	autoSync: Boolean
	//		if true refreshes the node list on every operation; false by default
	//	copyOnly: Boolean?
	//		copy items, if true, use a state of Ctrl key otherwise,
	//		see selfCopy and selfAccept for more details
	//	delay: Number
	//		the move delay in pixels before detecting a drag; 0 by default
	//	horizontal: Boolean?
	//		a horizontal container, if true, vertical otherwise or when omitted
	//	selfCopy: Boolean?
	//		copy items by default when dropping on itself,
	//		false by default, works only if copyOnly is true
	//	selfAccept: Boolean?
	//		accept its own items when copyOnly is true,
	//		true by default, works only if copyOnly is true
	//	withHandles: Boolean?
	//		allows dragging only by handles, false by default
	//  generateText: Boolean?
	//		generate text node for drag and drop, true by default
	this.isSource = isSource;
	this.accept = accept;
	this.autoSync = autoSync;
	this.copyOnly = copyOnly;
	this.delay = delay;
	this.horizontal = horizontal;
	this.selfCopy = selfCopy;
	this.selfAccept = selfAccept;
	this.withHandles = withHandles;
	this.generateText = true;
}
=====*/

dojo.declare("dojo.dnd.Source", dojo.dnd.Selector, {
	// summary:
	//		a Source object, which can be used as a DnD source, or a DnD target
	
	// object attributes (for markup)
	isSource: true,
	horizontal: false,
	copyOnly: false,
	selfCopy: false,
	selfAccept: true,
	skipForm: false,
	withHandles: false,
	autoSync: false,
	delay: 0, // pixels
	accept: ["text"],
	generateText: true,
	
	constructor: function(/*DOMNode|String*/node, /*dojo.dnd.__SourceArgs?*/params){
		// summary:
		//		a constructor of the Source
		// node:
		//		node or node's id to build the source on
		// params:
		//		any property of this class may be configured via the params
		//		object which is mixed-in to the `dojo.dnd.Source` instance
		dojo.mixin(this, dojo.mixin({}, params));
		var type = this.accept;
		if(type.length){
			this.accept = {};
			for(var i = 0; i < type.length; ++i){
				this.accept[type[i]] = 1;
			}
		}
		// class-specific variables
		this.isDragging = false;
		this.mouseDown = false;
		this.targetAnchor = null;
		this.targetBox = null;
		this.before = true;
		this._lastX = 0;
		this._lastY = 0;
		// states
		this.sourceState  = "";
		if(this.isSource){
			dojo.addClass(this.node, "dojoDndSource");
		}
		this.targetState  = "";
		if(this.accept){
			dojo.addClass(this.node, "dojoDndTarget");
		}
		if(this.horizontal){
			dojo.addClass(this.node, "dojoDndHorizontal");
		}
		// set up events
		this.topics = [
			dojo.subscribe("/dnd/source/over", this, "onDndSourceOver"),
			dojo.subscribe("/dnd/start",  this, "onDndStart"),
			dojo.subscribe("/dnd/drop",   this, "onDndDrop"),
			dojo.subscribe("/dnd/cancel", this, "onDndCancel")
		];
	},
	
	// methods
	checkAcceptance: function(source, nodes){
		// summary:
		//		checks if the target can accept nodes from this source
		// source: Object
		//		the source which provides items
		// nodes: Array
		//		the list of transferred items
		if(this == source){
			return !this.copyOnly || this.selfAccept;
		}
		for(var i = 0; i < nodes.length; ++i){
			var type = source.getItem(nodes[i].id).type;
			// type instanceof Array
			var flag = false;
			for(var j = 0; j < type.length; ++j){
				if(type[j] in this.accept){
					flag = true;
					break;
				}
			}
			if(!flag){
				return false;	// Boolean
			}
		}
		return true;	// Boolean
	},
	copyState: function(keyPressed, self){
		// summary:
		//		Returns true if we need to copy items, false to move.
		//		It is separated to be overwritten dynamically, if needed.
		// keyPressed: Boolean
		//		the "copy" key was pressed
		// self: Boolean?
		//		optional flag that means that we are about to drop on itself
		
		if(keyPressed){ return true; }
		if(arguments.length < 2){
			self = this == dojo.dnd.manager().target;
		}
		if(self){
			if(this.copyOnly){
				return this.selfCopy;
			}
		}else{
			return this.copyOnly;
		}
		return false;	// Boolean
	},
	destroy: function(){
		// summary:
		//		prepares the object to be garbage-collected
		dojo.dnd.Source.superclass.destroy.call(this);
		dojo.forEach(this.topics, dojo.unsubscribe);
		this.targetAnchor = null;
	},

	// markup methods
	markupFactory: function(params, node){
		params._skipStartup = true;
		return new dojo.dnd.Source(node, params);
	},

	// mouse event processors
	onMouseMove: function(e){
		// summary:
		//		event processor for onmousemove
		// e: Event
		//		mouse event
		if(this.isDragging && this.targetState == "Disabled"){ return; }
		dojo.dnd.Source.superclass.onMouseMove.call(this, e);
		var m = dojo.dnd.manager();
		if(!this.isDragging){
			if(this.mouseDown && this.isSource &&
					(Math.abs(e.pageX - this._lastX) > this.delay || Math.abs(e.pageY - this._lastY) > this.delay)){
				var nodes = this.getSelectedNodes();
				if(nodes.length){
					m.startDrag(this, nodes, this.copyState(dojo.isCopyKey(e), true));
				}
			}
		}
		if(this.isDragging){
			// calculate before/after
			var before = false;
			if(this.current){
				if(!this.targetBox || this.targetAnchor != this.current){
					this.targetBox = dojo.position(this.current, true);
				}
				if(this.horizontal){
					before = (e.pageX - this.targetBox.x) < (this.targetBox.w / 2);
				}else{
					before = (e.pageY - this.targetBox.y) < (this.targetBox.h / 2);
				}
			}
			if(this.current != this.targetAnchor || before != this.before){
				this._markTargetAnchor(before);
				m.canDrop(!this.current || m.source != this || !(this.current.id in this.selection));
			}
		}
	},
	onMouseDown: function(e){
		// summary:
		//		event processor for onmousedown
		// e: Event
		//		mouse event
		if(!this.mouseDown && this._legalMouseDown(e) && (!this.skipForm || !dojo.dnd.isFormElement(e))){
			this.mouseDown = true;
			this._lastX = e.pageX;
			this._lastY = e.pageY;
			dojo.dnd.Source.superclass.onMouseDown.call(this, e);
		}
	},
	onMouseUp: function(e){
		// summary:
		//		event processor for onmouseup
		// e: Event
		//		mouse event
		if(this.mouseDown){
			this.mouseDown = false;
			dojo.dnd.Source.superclass.onMouseUp.call(this, e);
		}
	},
	
	// topic event processors
	onDndSourceOver: function(source){
		// summary:
		//		topic event processor for /dnd/source/over, called when detected a current source
		// source: Object
		//		the source which has the mouse over it
		if(this != source){
			this.mouseDown = false;
			if(this.targetAnchor){
				this._unmarkTargetAnchor();
			}
		}else if(this.isDragging){
			var m = dojo.dnd.manager();
			m.canDrop(this.targetState != "Disabled" && (!this.current || m.source != this || !(this.current.id in this.selection)));
		}
	},
	onDndStart: function(source, nodes, copy){
		// summary:
		//		topic event processor for /dnd/start, called to initiate the DnD operation
		// source: Object
		//		the source which provides items
		// nodes: Array
		//		the list of transferred items
		// copy: Boolean
		//		copy items, if true, move items otherwise
		if(this.autoSync){ this.sync(); }
		if(this.isSource){
			this._changeState("Source", this == source ? (copy ? "Copied" : "Moved") : "");
		}
		var accepted = this.accept && this.checkAcceptance(source, nodes);
		this._changeState("Target", accepted ? "" : "Disabled");
		if(this == source){
			dojo.dnd.manager().overSource(this);
		}
		this.isDragging = true;
	},
	onDndDrop: function(source, nodes, copy, target){
		// summary:
		//		topic event processor for /dnd/drop, called to finish the DnD operation
		// source: Object
		//		the source which provides items
		// nodes: Array
		//		the list of transferred items
		// copy: Boolean
		//		copy items, if true, move items otherwise
		// target: Object
		//		the target which accepts items
		if(this == target){
			// this one is for us => move nodes!
			this.onDrop(source, nodes, copy);
		}
		this.onDndCancel();
	},
	onDndCancel: function(){
		// summary:
		//		topic event processor for /dnd/cancel, called to cancel the DnD operation
		if(this.targetAnchor){
			this._unmarkTargetAnchor();
			this.targetAnchor = null;
		}
		this.before = true;
		this.isDragging = false;
		this.mouseDown = false;
		this._changeState("Source", "");
		this._changeState("Target", "");
	},
	
	// local events
	onDrop: function(source, nodes, copy){
		// summary:
		//		called only on the current target, when drop is performed
		// source: Object
		//		the source which provides items
		// nodes: Array
		//		the list of transferred items
		// copy: Boolean
		//		copy items, if true, move items otherwise
		
		if(this != source){
			this.onDropExternal(source, nodes, copy);
		}else{
			this.onDropInternal(nodes, copy);
		}
	},
	onDropExternal: function(source, nodes, copy){
		// summary:
		//		called only on the current target, when drop is performed
		//		from an external source
		// source: Object
		//		the source which provides items
		// nodes: Array
		//		the list of transferred items
		// copy: Boolean
		//		copy items, if true, move items otherwise
		
		var oldCreator = this._normalizedCreator;
		// transferring nodes from the source to the target
		if(this.creator){
			// use defined creator
			this._normalizedCreator = function(node, hint){
				return oldCreator.call(this, source.getItem(node.id).data, hint);
			};
		}else{
			// we have no creator defined => move/clone nodes
			if(copy){
				// clone nodes
				this._normalizedCreator = function(node, hint){
					var t = source.getItem(node.id);
					var n = node.cloneNode(true);
					n.id = dojo.dnd.getUniqueId();
					return {node: n, data: t.data, type: t.type};
				};
			}else{
				// move nodes
				this._normalizedCreator = function(node, hint){
					var t = source.getItem(node.id);
					source.delItem(node.id);
					return {node: node, data: t.data, type: t.type};
				};
			}
		}
		this.selectNone();
		if(!copy && !this.creator){
			source.selectNone();
		}
		this.insertNodes(true, nodes, this.before, this.current);
		if(!copy && this.creator){
			source.deleteSelectedNodes();
		}
		this._normalizedCreator = oldCreator;
	},
	onDropInternal: function(nodes, copy){
		// summary:
		//		called only on the current target, when drop is performed
		//		from the same target/source
		// nodes: Array
		//		the list of transferred items
		// copy: Boolean
		//		copy items, if true, move items otherwise
		
		var oldCreator = this._normalizedCreator;
		// transferring nodes within the single source
		if(this.current && this.current.id in this.selection){
			// do nothing
			return;
		}
		if(copy){
			if(this.creator){
				// create new copies of data items
				this._normalizedCreator = function(node, hint){
					return oldCreator.call(this, this.getItem(node.id).data, hint);
				};
			}else{
				// clone nodes
				this._normalizedCreator = function(node, hint){
					var t = this.getItem(node.id);
					var n = node.cloneNode(true);
					n.id = dojo.dnd.getUniqueId();
					return {node: n, data: t.data, type: t.type};
				};
			}
		}else{
			// move nodes
			if(!this.current){
				// do nothing
				return;
			}
			this._normalizedCreator = function(node, hint){
				var t = this.getItem(node.id);
				return {node: node, data: t.data, type: t.type};
			};
		}
		this._removeSelection();
		this.insertNodes(true, nodes, this.before, this.current);
		this._normalizedCreator = oldCreator;
	},
	onDraggingOver: function(){
		// summary:
		//		called during the active DnD operation, when items
		//		are dragged over this target, and it is not disabled
	},
	onDraggingOut: function(){
		// summary:
		//		called during the active DnD operation, when items
		//		are dragged away from this target, and it is not disabled
	},
	
	// utilities
	onOverEvent: function(){
		// summary:
		//		this function is called once, when mouse is over our container
		dojo.dnd.Source.superclass.onOverEvent.call(this);
		dojo.dnd.manager().overSource(this);
		if(this.isDragging && this.targetState != "Disabled"){
			this.onDraggingOver();
		}
	},
	onOutEvent: function(){
		// summary:
		//		this function is called once, when mouse is out of our container
		dojo.dnd.Source.superclass.onOutEvent.call(this);
		dojo.dnd.manager().outSource(this);
		if(this.isDragging && this.targetState != "Disabled"){
			this.onDraggingOut();
		}
	},
	_markTargetAnchor: function(before){
		// summary:
		//		assigns a class to the current target anchor based on "before" status
		// before: Boolean
		//		insert before, if true, after otherwise
		if(this.current == this.targetAnchor && this.before == before){ return; }
		if(this.targetAnchor){
			this._removeItemClass(this.targetAnchor, this.before ? "Before" : "After");
		}
		this.targetAnchor = this.current;
		this.targetBox = null;
		this.before = before;
		if(this.targetAnchor){
			this._addItemClass(this.targetAnchor, this.before ? "Before" : "After");
		}
	},
	_unmarkTargetAnchor: function(){
		// summary:
		//		removes a class of the current target anchor based on "before" status
		if(!this.targetAnchor){ return; }
		this._removeItemClass(this.targetAnchor, this.before ? "Before" : "After");
		this.targetAnchor = null;
		this.targetBox = null;
		this.before = true;
	},
	_markDndStatus: function(copy){
		// summary:
		//		changes source's state based on "copy" status
		this._changeState("Source", copy ? "Copied" : "Moved");
	},
	_legalMouseDown: function(e){
		// summary:
		//		checks if user clicked on "approved" items
		// e: Event
		//		mouse event
		
		// accept only the left mouse button
		if(!dojo.mouseButtons.isLeft(e)){ return false; }
		
		if(!this.withHandles){ return true; }
		
		// check for handles
		for(var node = e.target; node && node !== this.node; node = node.parentNode){
			if(dojo.hasClass(node, "dojoDndHandle")){ return true; }
			if(dojo.hasClass(node, "dojoDndItem") || dojo.hasClass(node, "dojoDndIgnore")){ break; }
		}
		return false;	// Boolean
	}
});

dojo.declare("dojo.dnd.Target", dojo.dnd.Source, {
	// summary: a Target object, which can be used as a DnD target
	
	constructor: function(node, params){
		// summary:
		//		a constructor of the Target --- see the `dojo.dnd.Source.constructor` for details
		this.isSource = false;
		dojo.removeClass(this.node, "dojoDndSource");
	},

	// markup methods
	markupFactory: function(params, node){
		params._skipStartup = true;
		return new dojo.dnd.Target(node, params);
	}
});

dojo.declare("dojo.dnd.AutoSource", dojo.dnd.Source, {
	// summary:
	//		a source that syncs its DnD nodes by default
	
	constructor: function(node, params){
		// summary:
		//		constructor of the AutoSource --- see the Source constructor for details
		this.autoSync = true;
	},

	// markup methods
	markupFactory: function(params, node){
		params._skipStartup = true;
		return new dojo.dnd.AutoSource(node, params);
	}
});

}

if(!dojo._hasResource['epages.cartridges.de_epages.presentation.objectupdater']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.presentation.objectupdater'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.browser $Revision: 1.21 $

*/
dojo.provide('epages.cartridges.de_epages.presentation.objectupdater');





epages.cartridges.de_epages.presentation.ObjectUpdater = new epages.Class();
epages.cartridges.de_epages.presentation.ObjectUpdater.prototype = {
	siteId:       epages.vars.SiteID,
	initialize: function (options) {
		if (options !== undefined){
			dojo.mixin(this,options);
		}

		var tmpFunc = function() {
			var body = dojo.body();
			var stateHint = document.createElement("div");
			stateHint.appendChild(document.createTextNode('Loading...'));
			//dojo.addClass(stateHint, 'epagesObjectupdaterStateHint');
			stateHint.setAttribute('id', 'epagesObjectupdaterStateHint');
			stateHint.style.position = "absolute";
			stateHint.style.backgroundColor="red";
			stateHint.style.color = "white";
			stateHint.style.left = "150px";
			stateHint.style.top = "0px";
			stateHint.style.width = "150px";
			stateHint.style.height = "18px";
			stateHint.style.zIndex = "255";
			stateHint.style.display = "none";
			body.appendChild(stateHint);
		};

		if (dojo.body()) {
			if (!document.getElementById('epagesObjectupdaterStateHint')) {
				tmpFunc();
			}
		} else {
			dojo.addOnLoad(tmpFunc);
		}
	},

	getFormDataViaArray: function(/*ArrayLike*/data) {
	// depricated - will be removed in the next version
		var formData = [];
		$A(data).each( function(el) {
			formData.push($H(el).toQueryString());
		});
		return formData.join('&');
	},

	getFormDataViaHash: function(/*String*/guid, /*epages.lang.Hash||Object*/data) {
	  //alert("getFormDataViaHash is still in use!")
	  //used inside external content google map
		var formData = {
		  'GUID': [],
		  'Name': [],
		  'Value': []
		};
		$A($H(data).keys()).each( function(key) {
		  formData.GUID.push(guid);
		  formData.Name.push(key);
		  formData.Value.push(data[key]);
		});
		return formData;
	},

	getFormDataViaObjectForm: function(/*ObjectLike*/data) {
		var formData = {
		  'GUID': [],
		  'Name': [],
		  'Value': [],
		  'LocalizedGUID': [],
		  'LocalizedName': [],
		  'LocalizedValue': [],
		  'LanguageID': [],
		  'DeleteGUID': []
		};
		$H(data).each( function(el) {
			var hElement = el.key;
			var names = el.key.split(':');
			if (el.value == 'Delete')  {
			  formData.DeleteGUID.push(names[0]);
			} else if (names.length == 2) {
	  		  formData.GUID.push(names[0]);
	  		  formData.Name.push(names[1]);
	  		  // EPG-23763: Set value to '' if undefined
	  		  formData.Value.push(el.value ? el.value : '');
			} else if (names.length == 3) {
	  		  formData.LocalizedGUID.push(names[0]);
	  		  formData.LocalizedName.push(names[1]);
	  		  formData.LocalizedValue.push(el.value);
	  		  formData.LanguageID.push(names[2]);
			}
		});
		return formData;
	},

	sendAsync: function(/*String*/url, /*Object?*/formData, /*function?*/callback,isWizard/*boolean*/) {
		if (formData == ''){
			return;
		}
		var params = {
			ViewAction:   'JSONViewResponse',
			ObjectID:     this.siteId,
			ChangeAction: 'SaveGUIDList'
		};
		if(isWizard){
			params.IsWizard = true;
		}
		if (formData != null){
			dojo.mixin(params, formData);
		}
		var jsonIo = new epages.io.Json();
		jsonIo.loadAsync(url, callback, params, epages.io.json.defaultErrorCallback);
	}

};

}

if(!dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Toolcolor"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Toolcolor"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.Toolfont $Revision: 1.37 $

*/
/*global dojo,epages,tinyMCE,jQuery,ep*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.Toolcolor");



(function(){

var colorPicker;

dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.Toolcolor",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		label               : '',           // String - label of color field
		color               : '',           // String - color value
		colorType           : '',           // String - type of color input e.g. Background, ListeHeadBackground, ... (used for input name example: input name="${objectId}:${colorType}" value="myval" />)
		isBackgroundColor   : 'false',      // Boolean - flag that indicates that color is a Backgroundcolor
		templateType        : "tablerow",   // String - selected template type
		defaultTemplateType : "tablerow",   // [readonly] String - default value template type
		isTinyMCE           : 'false',      // Boolean - flag that indicates weather the current tinyMCE selection should be save or not
		'class'             : '',           // String - css class attribute
		userColors: epages.vars.userColors, // String - user defined colors e.g. "#ff0000|#000000"
		currentWizardScheme : 'Compound',   // String - selected color scheme
		objectId            : '',           // String - current epages object id
		styleId             : '',           // String - current epages object id
		allowEmpty          : '0',          // Boolean - allow empty value (will be passed to colorpicker widget)

		/**
		 * private properties
		 */
		_templateMapping:{
			'tablerow' : {templateString:"<tr class=\"ToolColor\"><td colspan=\"2\"><table><tr>\n  <td class=\"InputLabelling NoWrap\">${label}</td>\n  <td>\n    <input dojoAttachPoint=\"colorInputNode\"\n           class=\"Color\"\n           id=\"${colorType}\"\n           name=\"${objectId}:${colorType}\"\n           value=\"${color}\"\n           type=\"hidden\" />\n    <!-- insert color picker here -->\n    <div dojoAttachPoint=\"colorBoxNode\"\n         class=\"ColorBox EnableHover\"\n         style=\"background-color: ${color}\"\n         ></div>\n    <span dojoAttachPoint=\"notSetNode\" class=\"LeftSmallPadding AdditionalInfo\" style=\"display:none\">({NotSet})</span>\n  </td>\n</tr></table></td></tr>\n"},
			'tablerownew' : {templateString:"<tr class=\"ToolColor\">\n  <td class=\"InputLabelling NoWrap\">${label}</td>\n  <td class=\"FontSize\"></td>\n  <td>\n    <input dojoAttachPoint=\"colorInputNode\"\n           class=\"Color\"\n           id=\"${colorType}\"\n           name=\"${objectId}:${colorType}\"\n           value=\"${color}\"\n           type=\"hidden\" />\n    <!-- insert color picker here -->\n    <div dojoAttachPoint=\"colorBoxNode\"\n         class=\"ColorBox EnableHover\"\n         style=\"background-color: ${color}\"\n         ></div>\n    <span dojoAttachPoint=\"notSetNode\" class=\"LeftSmallPadding AdditionalInfo\" style=\"display:none\">({NotSet})</span>\n  </td>\n</tr>\n"},
			'colorbox' : {templateString:"<div class=\"ToolColor\">\n  <input dojoAttachPoint=\"colorInputNode\"\n         class=\"Color\"\n         id=\"${colorType}\"\n         name=\"${objectId}:${colorType}\"\n         value=\"${color}\"\n         type=\"hidden\" />\n  <!-- insert color picker here -->\n  <div dojoAttachPoint=\"colorBoxNode\"\n       class=\"ColorBox EnableHover\"\n       style=\"background-color: ${color}\"\n       ></div>\n  <span dojoAttachPoint=\"notSetNode\" class=\"LeftSmallPadding AdditionalInfo\" style=\"display:none\">({NotSet})</span>\n</div>\n"},
			'colorbutton' : {templateString:"<span class=\"ToolColor\">\n  <input dojoAttachPoint=\"colorInputNode\"\n         class=\"Color\"\n         id=\"${colorType}\"\n         name=\"${objectId}:${colorType}\"\n         value=\"${color}\"\n         type=\"hidden\" />\n  <!-- insert color picker here -->\n  <button dojoAttachPoint=\"colorBoxNode\"\n       class=\"ColorBox EnableHover\"\n       style=\"background-color: ${color}\"\n       ></button>\n  <span dojoAttachPoint=\"notSetNode\" class=\"LeftSmallPadding AdditionalInfo\" style=\"display:none\">({NotSet})</span>\n</span>\n"},
			'palette'  : {templateString:"<div class=\"ToolColor CommandSmallMedium Extend\"\n     dojoAttachPoint=\"clickNode\">\n  <input dojoAttachPoint=\"colorInputNode\"\n         class=\"Color\"\n         id=\"${colorType}\"\n         name=\"${objectId}:${colorType}\"\n         value=\"${color}\"\n         type=\"hidden\" />\n  <!-- insert color picker here -->\n  <div style=\"float: left\">\n    <img src=\"${imagePath}/ico_colorpalette_${_palette}.png\"\n         alt=\"${label}\" title=\"${label}\"\n         style=\"margin: 0 2px;\"\n         />\n    <div dojoAttachPoint=\"colorBoxNode\"\n         class=\"ColorBox Stripe EnableHover\"\n         style=\"background-color: ${color}\"\n         ></div>\n  </div>\n  <img style=\"margin: 2px 7px 0 7px;#margin: -5px 7px 0 7px;\"\n       src=\"${imagePath}/img_extend.png\"\n       />\n</div>\n"},
			'xlicon'   : {templateString:"<div class=\"ToolColor WithXLIcon\">\n  <input dojoAttachPoint=\"colorInputNode\"\n         class=\"Color\"\n         id=\"${colorType}\"\n         name=\"${objectId}:${colorType}\"\n         value=\"${color}\"\n         type=\"hidden\" />\n  <div class=\"CommandPane ExtraLarge\" dojoAttachPoint=\"clickNode\">\n    <i class=\"Sprite ico_xl_pickcolor\" title=\"{PickColor}\"></i><br />\n    ${label}<br />\n    <img src=\"${imagePath}/img_extend.png\"\n         alt=\"{PickColor}\" title=\"{PickColor}\" />\n    <div dojoAttachPoint=\"colorBoxNode\"\n         class=\"ColorBox Stripe EnableHover\"\n         style=\"background-color: ${color}\"\n         ></div>\n  </div>\n</div>\n"}
		},                                // [protected] Object - hash which associates templateType key with template filename
		_palette            : 'fore',     // [protected] String - template variable used in template Toolcolorpalette (icon switch)
		_tinyMceSelection   : undefined,  // [protected] TinyMceSelection - current selection in tiny mce editor

		/**
		 * constants
		 */
		COLORPICKER_OFFSET_X: 18,         // [const] Integer
		COLORPICKER_OFFSET_Y: 0,          // [const] Integer

		/**
		 * widget properties
		 */
		templateString:"<tr class=\"ToolColor\"><td colspan=\"2\"><table><tr>\n  <td class=\"InputLabelling NoWrap\">${label}</td>\n  <td>\n    <input dojoAttachPoint=\"colorInputNode\"\n           class=\"Color\"\n           id=\"${colorType}\"\n           name=\"${objectId}:${colorType}\"\n           value=\"${color}\"\n           type=\"hidden\" />\n    <!-- insert color picker here -->\n    <div dojoAttachPoint=\"colorBoxNode\"\n         class=\"ColorBox EnableHover\"\n         style=\"background-color: ${color}\"\n         ></div>\n    <span dojoAttachPoint=\"notSetNode\" class=\"LeftSmallPadding AdditionalInfo\" style=\"display:none\">({NotSet})</span>\n  </td>\n</tr></table></td></tr>\n",  // String - template path + filename
		imagePath       : epages.themeUrl('images'),                                                                      // String - icon path
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', 'templates/translation'),     // String - translation path + filename

		postMixInProperties: function() {
		// summary: initialize values
			this._templateDirectory = dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', 'templates');
			this.inherited("postMixInProperties", arguments);
			this.isBackgroundColor = epages.string.toBoolean(this.isBackgroundColor);
			this.isTinyMCE = epages.string.toBoolean(this.isTinyMCE);
			this.allowEmpty = epages.string.toBoolean(this.allowEmpty);
			this._palette = this.isBackgroundColor ? 'back' : 'fore';
			if(this.color === '' && ! this.allowEmpty) {
				this.color = 'transparent';
			}
			this.styleId = epages.vars.StyleId === undefined ? '' : epages.vars.StyleId;
		},

		postCreate  : function() {
		// summary: initialize widget / append events
			this.inherited("postCreate", arguments);

			dojo.addClass(this.domNode,this['class']);
			if(this.objectId === '') {
				this.colorInputNode.name=this.colorType;
			}
			this._appendEvents();
			this._changeColorBoxColor();
		},

		/**
		 * private methods
		 */

		_appendEvents: function() {
		// summary: append events to buttons (bold, italic, underline)
			this.connect(this.colorInputNode,     'onchange', '_changeColorBoxColor');

			// save selection in editor iframe for msie
			if (this.isTinyMCE && epages.Browser.engine === "MSIE"){
				this.connect(this.clickNode,        'onmousedown', '_tinyMceSaveSelection');
			}

			// open color picker
			if(this.clickNode){
				this.connect(this.clickNode,        'onclick', '_openColorPicker');
			}else{
				this.connect(this.colorBoxNode,     'onclick', '_openColorPicker');
			}
		},

		_changeColorBoxColor: function() {
			// summary: set background color of color preview box
			var color=this.colorInputNode.value;

			if(this.notSetNode) {	// this node does not exisit within every template type
				if(color === "") {
					this.notSetNode.style.display="";
				} else {
					this.notSetNode.style.display="none";
				}
			}

			// set color preview

			if(this.templateType === 'colorbutton'){
				this.colorBoxNode.style.background=color;
			}
			else{
				this.colorBoxNode.style.backgroundColor=color;
			}
			if(color==='transparent') {
				dojo.addClass(this.colorBoxNode,"Transparent");
			} else {
				dojo.removeClass(this.colorBoxNode,"Transparent");
			}

			if (this.isTinyMCE && tinyMCE.selectedInstance !== null) {
				if(this._tinyMceSelection === undefined) {
					tinyMCE.execCommand((this.isBackgroundColor ? 'HiliteColor': 'forecolor'), false, color);
				} else { // IE only - tinymce fixes
					this._tinyMceSelection.execCommand((this.isBackgroundColor ? 'BackColor': 'forecolor'), false, color);
					tinyMCE.activeEditor.focus();
					tinyMCE.activeEditor.selection.setRng(this._tinyMceSelection);
					this._tinyMceSelection=undefined;
				}
			}
		},

		_openColorPicker: function( event ) {
			var self = this,
				colorTarget = ep(event.target),
				colorInput = jQuery(this.colorInputNode);

			if( colorPicker ){
				colorPicker.element = colorPicker.elem = colorTarget;
				colorPicker.option( 'callback', function( color ){
					colorTarget
						.css('background-color', color);
					colorInput
						.val( color )
						.trigger({ type:'change', dojoconnect:true });
				});
				colorPicker.colorSelect( colorInput.val(), true );
				colorPicker.open();
			}
			else{
				jQuery.ready( ['ep.ajax', 'ep.ui.colorpicker'], function($){
					var options = {
							orientation:	'bottom'
						};

					if( epages.vars.StyleUserDefinedColors ){
						var extended = {
								baseColors:	$('#LayoutBackgroundColor').val(),
								userColors: {},
								userColorsSave: function( data ){
									var ajaxData = [
											{name: 'ViewAction',	value: 'JSONViewResponse'},
											{name: 'ChangeAction',	value: 'SaveGUIDList'},
											{name: 'ObjectID',		value: ep.config.siteId}
										];

									$.each( data, function(){
										ajaxData.push(
											{name: 'GUID',			value: self.styleId},
											{name: 'Name',			value: this.name},
											{name: 'Value',			value: this.value}
										);
									});

									ep.ajax({
										type:		'post',
										dataType:	'json',
										data:		ajaxData
									});
								}
							};

						$.each( epages.vars.StyleUserDefinedColors.split('|'), function( i, val ){
							extended.userColors[ 'UserDefinedColor'+i ] = val;
						});

						options.extended = extended;
					}

					colorPicker = ep('<div>')
						.uiColorpicker(options)
						.uiColorpicker('Instance');
					self._openColorPicker( event );
				});
			}
		},

		_tinyMceSaveSelection: function() {
		// summary: stores the current tinymce select
			if(tinyMCE.activeEditor && tinyMCE.activeEditor.selection){
				this._tinyMceSelection = tinyMCE.activeEditor.selection.getRng();
		}

		}
	});

}());

}

if(!dojo._hasResource["dijit.form.ToggleButton"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form.ToggleButton"] = true;
dojo.provide("dijit.form.ToggleButton");




}

if(!dojo._hasResource["dijit.layout.StackController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.StackController"] = true;
dojo.provide("dijit.layout.StackController");







dojo.declare(
		"dijit.layout.StackController",
		[dijit._Widget, dijit._Templated, dijit._Container],
		{
			// summary:
			//		Set of buttons to select a page in a page list.
			// description:
			//		Monitors the specified StackContainer, and whenever a page is
			//		added, deleted, or selected, updates itself accordingly.

			templateString: "<span role='tablist' dojoAttachEvent='onkeypress' class='dijitStackController'></span>",

			// containerId: [const] String
			//		The id of the page container that I point to
			containerId: "",

			// buttonWidget: [const] String
			//		The name of the button widget to create to correspond to each page
			buttonWidget: "dijit.layout._StackButton",

			constructor: function(){
				this.pane2button = {};		// mapping from pane id to buttons
				this.pane2connects = {};	// mapping from pane id to this.connect() handles
				this.pane2watches = {};		// mapping from pane id to watch() handles
			},

			buildRendering: function(){
				this.inherited(arguments);
				dijit.setWaiRole(this.domNode, "tablist");	// TODO: unneeded?   it's in template above.
			},

			postCreate: function(){
				this.inherited(arguments);

				// Listen to notifications from StackContainer
				this.subscribe(this.containerId+"-startup", "onStartup");
				this.subscribe(this.containerId+"-addChild", "onAddChild");
				this.subscribe(this.containerId+"-removeChild", "onRemoveChild");
				this.subscribe(this.containerId+"-selectChild", "onSelectChild");
				this.subscribe(this.containerId+"-containerKeyPress", "onContainerKeyPress");
			},

			onStartup: function(/*Object*/ info){
				// summary:
				//		Called after StackContainer has finished initializing
				// tags:
				//		private
				dojo.forEach(info.children, this.onAddChild, this);
				if(info.selected){
					// Show button corresponding to selected pane (unless selected
					// is null because there are no panes)
					this.onSelectChild(info.selected);
				}
			},

			destroy: function(){
				for(var pane in this.pane2button){
					this.onRemoveChild(dijit.byId(pane));
				}
				this.inherited(arguments);
			},

			onAddChild: function(/*dijit._Widget*/ page, /*Integer?*/ insertIndex){
				// summary:
				//		Called whenever a page is added to the container.
				//		Create button corresponding to the page.
				// tags:
				//		private

				// create an instance of the button widget
				var cls = dojo.getObject(this.buttonWidget);
				var button = new cls({
					id: this.id + "_" + page.id,
					label: page.title,
					dir: page.dir,
					lang: page.lang,
					showLabel: page.showTitle,
					iconClass: page.iconClass,
					closeButton: page.closable,
					title: page.tooltip
				});
				dijit.setWaiState(button.focusNode,"selected", "false");


				// map from page attribute to corresponding tab button attribute
				var pageAttrList = ["title", "showTitle", "iconClass", "closable", "tooltip"],
					buttonAttrList = ["label", "showLabel", "iconClass", "closeButton", "title"];

				// watch() so events like page title changes are reflected in tab button
				this.pane2watches[page.id] = dojo.map(pageAttrList, function(pageAttr, idx){
					return page.watch(pageAttr, function(name, oldVal, newVal){
						button.set(buttonAttrList[idx], newVal);
					});
				});
					
				// connections so that clicking a tab button selects the corresponding page
				this.pane2connects[page.id] = [
					this.connect(button, 'onClick', dojo.hitch(this,"onButtonClick", page)),
					this.connect(button, 'onClickCloseButton', dojo.hitch(this,"onCloseButtonClick", page))
				];

				this.addChild(button, insertIndex);
				this.pane2button[page.id] = button;
				page.controlButton = button;	// this value might be overwritten if two tabs point to same container
				if(!this._currentChild){ // put the first child into the tab order
					button.focusNode.setAttribute("tabIndex", "0");
					dijit.setWaiState(button.focusNode, "selected", "true");
					this._currentChild = page;
				}
				// make sure all tabs have the same length
				if(!this.isLeftToRight() && dojo.isIE && this._rectifyRtlTabList){
					this._rectifyRtlTabList();
				}
			},

			onRemoveChild: function(/*dijit._Widget*/ page){
				// summary:
				//		Called whenever a page is removed from the container.
				//		Remove the button corresponding to the page.
				// tags:
				//		private

				if(this._currentChild === page){ this._currentChild = null; }

				// disconnect/unwatch connections/watches related to page being removed
				dojo.forEach(this.pane2connects[page.id], dojo.hitch(this, "disconnect"));
				delete this.pane2connects[page.id];
				dojo.forEach(this.pane2watches[page.id], function(w){ w.unwatch(); });
				delete this.pane2watches[page.id];

				var button = this.pane2button[page.id];
				if(button){
					this.removeChild(button);
					delete this.pane2button[page.id];
					button.destroy();
				}
				delete page.controlButton;
			},

			onSelectChild: function(/*dijit._Widget*/ page){
				// summary:
				//		Called when a page has been selected in the StackContainer, either by me or by another StackController
				// tags:
				//		private

				if(!page){ return; }

				if(this._currentChild){
					var oldButton=this.pane2button[this._currentChild.id];
					oldButton.set('checked', false);
					dijit.setWaiState(oldButton.focusNode, "selected", "false");
					oldButton.focusNode.setAttribute("tabIndex", "-1");
				}

				var newButton=this.pane2button[page.id];
				newButton.set('checked', true);
				dijit.setWaiState(newButton.focusNode, "selected", "true");
				this._currentChild = page;
				newButton.focusNode.setAttribute("tabIndex", "0");
				var container = dijit.byId(this.containerId);
				dijit.setWaiState(container.containerNode, "labelledby", newButton.id);
			},

			onButtonClick: function(/*dijit._Widget*/ page){
				// summary:
				//		Called whenever one of my child buttons is pressed in an attempt to select a page
				// tags:
				//		private

				var container = dijit.byId(this.containerId);
				container.selectChild(page);
			},

			onCloseButtonClick: function(/*dijit._Widget*/ page){
				// summary:
				//		Called whenever one of my child buttons [X] is pressed in an attempt to close a page
				// tags:
				//		private

				var container = dijit.byId(this.containerId);
				container.closeChild(page);
				if(this._currentChild){
					var b = this.pane2button[this._currentChild.id];
					if(b){
						dijit.focus(b.focusNode || b.domNode);
					}
				}
			},

			// TODO: this is a bit redundant with forward, back api in StackContainer
			adjacent: function(/*Boolean*/ forward){
				// summary:
				//		Helper for onkeypress to find next/previous button
				// tags:
				//		private

				if(!this.isLeftToRight() && (!this.tabPosition || /top|bottom/.test(this.tabPosition))){ forward = !forward; }
				// find currently focused button in children array
				var children = this.getChildren();
				var current = dojo.indexOf(children, this.pane2button[this._currentChild.id]);
				// pick next button to focus on
				var offset = forward ? 1 : children.length - 1;
				return children[ (current + offset) % children.length ]; // dijit._Widget
			},

			onkeypress: function(/*Event*/ e){
				// summary:
				//		Handle keystrokes on the page list, for advancing to next/previous button
				//		and closing the current page if the page is closable.
				// tags:
				//		private

				if(this.disabled || e.altKey ){ return; }
				var forward = null;
				if(e.ctrlKey || !e._djpage){
					var k = dojo.keys;
					switch(e.charOrCode){
						case k.LEFT_ARROW:
						case k.UP_ARROW:
							if(!e._djpage){ forward = false; }
							break;
						case k.PAGE_UP:
							if(e.ctrlKey){ forward = false; }
							break;
						case k.RIGHT_ARROW:
						case k.DOWN_ARROW:
							if(!e._djpage){ forward = true; }
							break;
						case k.PAGE_DOWN:
							if(e.ctrlKey){ forward = true; }
							break;
						case k.HOME:
						case k.END:
							var children = this.getChildren();
							if(children && children.length){
								children[e.charOrCode == k.HOME ? 0 : children.length-1].onClick();
							}
							dojo.stopEvent(e);
							break;
						case k.DELETE:
							if(this._currentChild.closable){
								this.onCloseButtonClick(this._currentChild);
							}
							dojo.stopEvent(e);
							break;
						default:
							if(e.ctrlKey){
								if(e.charOrCode === k.TAB){
									this.adjacent(!e.shiftKey).onClick();
									dojo.stopEvent(e);
								}else if(e.charOrCode == "w"){
									if(this._currentChild.closable){
										this.onCloseButtonClick(this._currentChild);
									}
									dojo.stopEvent(e); // avoid browser tab closing.
								}
							}
					}
					// handle next/previous page navigation (left/right arrow, etc.)
					if(forward !== null){
						this.adjacent(forward).onClick();
						dojo.stopEvent(e);
					}
				}
			},

			onContainerKeyPress: function(/*Object*/ info){
				// summary:
				//		Called when there was a keypress on the container
				// tags:
				//		private
				info.e._djpage = info.page;
				this.onkeypress(info.e);
			}
	});


dojo.declare("dijit.layout._StackButton",
		dijit.form.ToggleButton,
		{
		// summary:
		//		Internal widget used by StackContainer.
		// description:
		//		The button-like or tab-like object you click to select or delete a page
		// tags:
		//		private

		// Override _FormWidget.tabIndex.
		// StackContainer buttons are not in the tab order by default.
		// Probably we should be calling this.startupKeyNavChildren() instead.
		tabIndex: "-1",

		buildRendering: function(/*Event*/ evt){
			this.inherited(arguments);
			dijit.setWaiRole((this.focusNode || this.domNode), "tab");
		},

		onClick: function(/*Event*/ evt){
			// summary:
			//		This is for TabContainer where the tabs are <span> rather than button,
			//		so need to set focus explicitly (on some browsers)
			//		Note that you shouldn't override this method, but you can connect to it.
			dijit.focus(this.focusNode);

			// ... now let StackController catch the event and tell me what to do
		},

		onClickCloseButton: function(/*Event*/ evt){
			// summary:
			//		StackContainer connects to this function; if your widget contains a close button
			//		then clicking it should call this function.
			//		Note that you shouldn't override this method, but you can connect to it.
			evt.stopPropagation();
		}
	});

}

if(!dojo._hasResource["dijit.layout.StackContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.StackContainer"] = true;
dojo.provide("dijit.layout.StackContainer");







dojo.declare(
	"dijit.layout.StackContainer",
	dijit.layout._LayoutWidget,
	{
	// summary:
	//		A container that has multiple children, but shows only
	//		one child at a time
	//
	// description:
	//		A container for widgets (ContentPanes, for example) That displays
	//		only one Widget at a time.
	//
	//		Publishes topics [widgetId]-addChild, [widgetId]-removeChild, and [widgetId]-selectChild
	//
	//		Can be base class for container, Wizard, Show, etc.

	// doLayout: Boolean
	//		If true, change the size of my currently displayed child to match my size
	doLayout: true,

	// persist: Boolean
	//		Remembers the selected child across sessions
	persist: false,

	baseClass: "dijitStackContainer",

/*=====
	// selectedChildWidget: [readonly] dijit._Widget
	//		References the currently selected child widget, if any.
	//		Adjust selected child with selectChild() method.
	selectedChildWidget: null,
=====*/

	buildRendering: function(){
		this.inherited(arguments);
		dojo.addClass(this.domNode, "dijitLayoutContainer");
		dijit.setWaiRole(this.containerNode, "tabpanel");
	},

	postCreate: function(){
		this.inherited(arguments);
		this.connect(this.domNode, "onkeypress", this._onKeyPress);
	},

	startup: function(){
		if(this._started){ return; }

		var children = this.getChildren();

		// Setup each page panel to be initially hidden
		dojo.forEach(children, this._setupChild, this);

		// Figure out which child to initially display, defaulting to first one
		if(this.persist){
			this.selectedChildWidget = dijit.byId(dojo.cookie(this.id + "_selectedChild"));
		}else{
			dojo.some(children, function(child){
				if(child.selected){
					this.selectedChildWidget = child;
				}
				return child.selected;
			}, this);
		}
		var selected = this.selectedChildWidget;
		if(!selected && children[0]){
			selected = this.selectedChildWidget = children[0];
			selected.selected = true;
		}

		// Publish information about myself so any StackControllers can initialize.
		// This needs to happen before this.inherited(arguments) so that for
		// TabContainer, this._contentBox doesn't include the space for the tab labels.
		dojo.publish(this.id+"-startup", [{children: children, selected: selected}]);

		// Startup each child widget, and do initial layout like setting this._contentBox,
		// then calls this.resize() which does the initial sizing on the selected child.
		this.inherited(arguments);
	},

	resize: function(){
		// Resize is called when we are first made visible (it's called from startup()
		// if we are initially visible).   If this is the first time we've been made
		// visible then show our first child.
		var selected = this.selectedChildWidget;
		if(selected && !this._hasBeenShown){
			this._hasBeenShown = true;
			this._showChild(selected);
		}
		this.inherited(arguments);
	},

	_setupChild: function(/*dijit._Widget*/ child){
		// Overrides _LayoutWidget._setupChild()

		this.inherited(arguments);

		dojo.replaceClass(child.domNode, "dijitHidden", "dijitVisible");

		// remove the title attribute so it doesn't show up when i hover
		// over a node
		child.domNode.title = "";
	},

	addChild: function(/*dijit._Widget*/ child, /*Integer?*/ insertIndex){
		// Overrides _Container.addChild() to do layout and publish events

		this.inherited(arguments);

		if(this._started){
			dojo.publish(this.id+"-addChild", [child, insertIndex]);

			// in case the tab titles have overflowed from one line to two lines
			// (or, if this if first child, from zero lines to one line)
			// TODO: w/ScrollingTabController this is no longer necessary, although
			// ScrollTabController.resize() does need to get called to show/hide
			// the navigation buttons as appropriate, but that's handled in ScrollingTabController.onAddChild()
			this.layout();

			// if this is the first child, then select it
			if(!this.selectedChildWidget){
				this.selectChild(child);
			}
		}
	},

	removeChild: function(/*dijit._Widget*/ page){
		// Overrides _Container.removeChild() to do layout and publish events

		this.inherited(arguments);

		if(this._started){
			// this will notify any tablists to remove a button; do this first because it may affect sizing
			dojo.publish(this.id + "-removeChild", [page]);
		}

		// If we are being destroyed than don't run the code below (to select another page), because we are deleting
		// every page one by one
		if(this._beingDestroyed){ return; }

		// Select new page to display, also updating TabController to show the respective tab.
		// Do this before layout call because it can affect the height of the TabController.
		if(this.selectedChildWidget === page){
			this.selectedChildWidget = undefined;
			if(this._started){
				var children = this.getChildren();
				if(children.length){
					this.selectChild(children[0]);
				}
			}
		}

		if(this._started){
			// In case the tab titles now take up one line instead of two lines
			// (note though that ScrollingTabController never overflows to multiple lines),
			// or the height has changed slightly because of addition/removal of tab which close icon
			this.layout();
		}
	},

	selectChild: function(/*dijit._Widget|String*/ page, /*Boolean*/ animate){
		// summary:
		//		Show the given widget (which must be one of my children)
		// page:
		//		Reference to child widget or id of child widget

		page = dijit.byId(page);

		if(this.selectedChildWidget != page){
			// Deselect old page and select new one
			var d = this._transition(page, this.selectedChildWidget, animate);
			this._set("selectedChildWidget", page);
			dojo.publish(this.id+"-selectChild", [page]);

			if(this.persist){
				dojo.cookie(this.id + "_selectedChild", this.selectedChildWidget.id);
			}
		}

		return d;		// If child has an href, promise that fires when the child's href finishes loading
	},

	_transition: function(/*dijit._Widget*/ newWidget, /*dijit._Widget*/ oldWidget, /*Boolean*/ animate){
		// summary:
		//		Hide the old widget and display the new widget.
		//		Subclasses should override this.
		// tags:
		//		protected extension
		if(oldWidget){
			this._hideChild(oldWidget);
		}
		var d = this._showChild(newWidget);

		// Size the new widget, in case this is the first time it's being shown,
		// or I have been resized since the last time it was shown.
		// Note that page must be visible for resizing to work.
		if(newWidget.resize){
			if(this.doLayout){
				newWidget.resize(this._containerContentBox || this._contentBox);
			}else{
				// the child should pick it's own size but we still need to call resize()
				// (with no arguments) to let the widget lay itself out
				newWidget.resize();
			}
		}

		return d;	// If child has an href, promise that fires when the child's href finishes loading
	},

	_adjacent: function(/*Boolean*/ forward){
		// summary:
		//		Gets the next/previous child widget in this container from the current selection.
		var children = this.getChildren();
		var index = dojo.indexOf(children, this.selectedChildWidget);
		index += forward ? 1 : children.length - 1;
		return children[ index % children.length ]; // dijit._Widget
	},

	forward: function(){
		// summary:
		//		Advance to next page.
		return this.selectChild(this._adjacent(true), true);
	},

	back: function(){
		// summary:
		//		Go back to previous page.
		return this.selectChild(this._adjacent(false), true);
	},

	_onKeyPress: function(e){
		dojo.publish(this.id+"-containerKeyPress", [{ e: e, page: this}]);
	},

	layout: function(){
		// Implement _LayoutWidget.layout() virtual method.
		if(this.doLayout && this.selectedChildWidget && this.selectedChildWidget.resize){
			this.selectedChildWidget.resize(this._containerContentBox || this._contentBox);
		}
	},

	_showChild: function(/*dijit._Widget*/ page){
		// summary:
		//		Show the specified child by changing it's CSS, and call _onShow()/onShow() so
		//		it can do any updates it needs regarding loading href's etc.
		// returns:
		//		Promise that fires when page has finished showing, or true if there's no href
		var children = this.getChildren();
		page.isFirstChild = (page == children[0]);
		page.isLastChild = (page == children[children.length-1]);
		page._set("selected", true);

		dojo.replaceClass(page.domNode, "dijitVisible", "dijitHidden");

		return page._onShow() || true;
	},

	_hideChild: function(/*dijit._Widget*/ page){
		// summary:
		//		Hide the specified child by changing it's CSS, and call _onHide() so
		//		it's notified.
		page._set("selected", false);
		dojo.replaceClass(page.domNode, "dijitHidden", "dijitVisible");

		page.onHide();
	},

	closeChild: function(/*dijit._Widget*/ page){
		// summary:
		//		Callback when user clicks the [X] to remove a page.
		//		If onClose() returns true then remove and destroy the child.
		// tags:
		//		private
		var remove = page.onClose(this, page);
		if(remove){
			this.removeChild(page);
			// makes sure we can clean up executeScripts in ContentPane onUnLoad
			page.destroyRecursive();
		}
	},

	destroyDescendants: function(/*Boolean*/ preserveDom){
		dojo.forEach(this.getChildren(), function(child){
			this.removeChild(child);
			child.destroyRecursive(preserveDom);
		}, this);
	}
});

// For back-compat, remove for 2.0


// These arguments can be specified for the children of a StackContainer.
// Since any widget can be specified as a StackContainer child, mix them
// into the base widget class.  (This is a hack, but it's effective.)
dojo.extend(dijit._Widget, {
	// selected: Boolean
	//		Parameter for children of `dijit.layout.StackContainer` or subclasses.
	//		Specifies that this widget should be the initially displayed pane.
	//		Note: to change the selected child use `dijit.layout.StackContainer.selectChild`
	selected: false,

	// closable: Boolean
	//		Parameter for children of `dijit.layout.StackContainer` or subclasses.
	//		True if user can close (destroy) this child, such as (for example) clicking the X on the tab.
	closable: false,

	// iconClass: String
	//		Parameter for children of `dijit.layout.StackContainer` or subclasses.
	//		CSS Class specifying icon to use in label associated with this pane.
	iconClass: "",

	// showTitle: Boolean
	//		Parameter for children of `dijit.layout.StackContainer` or subclasses.
	//		When true, display title of this widget as tab label etc., rather than just using
	//		icon specified in iconClass
	showTitle: true
});

}

if(!dojo._hasResource["dijit.layout.AccordionPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.AccordionPane"] = true;
dojo.provide("dijit.layout.AccordionPane");



dojo.declare("dijit.layout.AccordionPane", dijit.layout.ContentPane, {
	// summary:
	//		Deprecated widget.   Use `dijit.layout.ContentPane` instead.
	// tags:
	//		deprecated

	constructor: function(){
		dojo.deprecated("dijit.layout.AccordionPane deprecated, use ContentPane instead", "", "2.0");
	},

	onSelected: function(){
		// summary:
		//		called when this pane is selected
	}
});

}

if(!dojo._hasResource["dijit.layout.AccordionContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.AccordionContainer"] = true;
dojo.provide("dijit.layout.AccordionContainer");








//dojo.require("dijit.layout.AccordionPane ");	// for back compat, remove for 2.0

// Design notes:
//
// An AccordionContainer is a StackContainer, but each child (typically ContentPane)
// is wrapped in a _AccordionInnerContainer.   This is hidden from the caller.
//
// The resulting markup will look like:
//
//	<div class=dijitAccordionContainer>
//		<div class=dijitAccordionInnerContainer>	(one pane)
//				<div class=dijitAccordionTitle>		(title bar) ... </div>
//				<div class=dijtAccordionChildWrapper>   (content pane) </div>
//		</div>
//	</div>
//
// Normally the dijtAccordionChildWrapper is hidden for all but one child (the shown
// child), so the space for the content pane is all the title bars + the one dijtAccordionChildWrapper,
// which on claro has a 1px border plus a 2px bottom margin.
//
// During animation there are two dijtAccordionChildWrapper's shown, so we need
// to compensate for that.

dojo.declare(
	"dijit.layout.AccordionContainer",
	dijit.layout.StackContainer,
	{
		// summary:
		//		Holds a set of panes where every pane's title is visible, but only one pane's content is visible at a time,
		//		and switching between panes is visualized by sliding the other panes up/down.
		// example:
		//	| 	<div dojoType="dijit.layout.AccordionContainer">
		//	|		<div dojoType="dijit.layout.ContentPane" title="pane 1">
		//	|		</div>
		//	|		<div dojoType="dijit.layout.ContentPane" title="pane 2">
		//	|			<p>This is some text</p>
		//	|		</div>
		//	|	</div>

		// duration: Integer
		//		Amount of time (in ms) it takes to slide panes
		duration: dijit.defaultDuration,

		// buttonWidget: [const] String
		//		The name of the widget used to display the title of each pane
		buttonWidget: "dijit.layout._AccordionButton",

/*=====
		// _verticalSpace: Number
		//		Pixels of space available for the open pane
		//		(my content box size minus the cumulative size of all the title bars)
		_verticalSpace: 0,
=====*/
		baseClass: "dijitAccordionContainer",

		buildRendering: function(){
			this.inherited(arguments);
			this.domNode.style.overflow = "hidden";		// TODO: put this in dijit.css
			dijit.setWaiRole(this.domNode, "tablist");	// TODO: put this in template
		},

		startup: function(){
			if(this._started){ return; }
			this.inherited(arguments);
			if(this.selectedChildWidget){
				var style = this.selectedChildWidget.containerNode.style;
				style.display = "";
				style.overflow = "auto";
				this.selectedChildWidget._wrapperWidget.set("selected", true);
			}
		},

		layout: function(){
			// Implement _LayoutWidget.layout() virtual method.
			// Set the height of the open pane based on what room remains.

			var openPane = this.selectedChildWidget;
			
			if(!openPane){ return;}

			// space taken up by title, plus wrapper div (with border/margin) for open pane
			var wrapperDomNode = openPane._wrapperWidget.domNode,
				wrapperDomNodeMargin = dojo._getMarginExtents(wrapperDomNode),
				wrapperDomNodePadBorder = dojo._getPadBorderExtents(wrapperDomNode),
				wrapperContainerNode = openPane._wrapperWidget.containerNode,
				wrapperContainerNodeMargin = dojo._getMarginExtents(wrapperContainerNode),
				wrapperContainerNodePadBorder = dojo._getPadBorderExtents(wrapperContainerNode),
				mySize = this._contentBox;

			// get cumulative height of all the unselected title bars
			var totalCollapsedHeight = 0;
			dojo.forEach(this.getChildren(), function(child){
	            if(child != openPane){
					totalCollapsedHeight += dojo._getMarginSize(child._wrapperWidget.domNode).h;
				}
			});
			this._verticalSpace = mySize.h - totalCollapsedHeight - wrapperDomNodeMargin.h
			 	- wrapperDomNodePadBorder.h - wrapperContainerNodeMargin.h - wrapperContainerNodePadBorder.h
				- openPane._buttonWidget.getTitleHeight();

			// Memo size to make displayed child
			this._containerContentBox = {
				h: this._verticalSpace,
				w: this._contentBox.w - wrapperDomNodeMargin.w - wrapperDomNodePadBorder.w
					- wrapperContainerNodeMargin.w - wrapperContainerNodePadBorder.w
			};

			if(openPane){
				openPane.resize(this._containerContentBox);
			}
		},

		_setupChild: function(child){
			// Overrides _LayoutWidget._setupChild().
			// Put wrapper widget around the child widget, showing title

			child._wrapperWidget = new dijit.layout._AccordionInnerContainer({
				contentWidget: child,
				buttonWidget: this.buttonWidget,
				id: child.id + "_wrapper",
				dir: child.dir,
				lang: child.lang,
				parent: this
			});

			this.inherited(arguments);
		},

		addChild: function(/*dijit._Widget*/ child, /*Integer?*/ insertIndex){
			if(this._started){
				// Adding a child to a started Accordion is complicated because children have
				// wrapper widgets.  Default code path (calling this.inherited()) would add
				// the new child inside another child's wrapper.

				// First add in child as a direct child of this AccordionContainer
				dojo.place(child.domNode, this.containerNode, insertIndex);

				if(!child._started){
					child.startup();
				}
				
				// Then stick the wrapper widget around the child widget
				this._setupChild(child);

				// Code below copied from StackContainer
				dojo.publish(this.id+"-addChild", [child, insertIndex]);
				this.layout();
				if(!this.selectedChildWidget){
					this.selectChild(child);
				}
			}else{
				// We haven't been started yet so just add in the child widget directly,
				// and the wrapper will be created on startup()
				this.inherited(arguments);
			}
		},

		removeChild: function(child){
			// Overrides _LayoutWidget.removeChild().

			// Destroy wrapper widget first, before StackContainer.getChildren() call.
			// Replace wrapper widget with true child widget (ContentPane etc.).
			// This step only happens if the AccordionContainer has been started; otherwise there's no wrapper.
			if(child._wrapperWidget){
				dojo.place(child.domNode, child._wrapperWidget.domNode, "after");
				child._wrapperWidget.destroy();
				delete child._wrapperWidget;
			}

			dojo.removeClass(child.domNode, "dijitHidden");

			this.inherited(arguments);
		},

		getChildren: function(){
			// Overrides _Container.getChildren() to return content panes rather than internal AccordionInnerContainer panes
			return dojo.map(this.inherited(arguments), function(child){
				return child.declaredClass == "dijit.layout._AccordionInnerContainer" ? child.contentWidget : child;
			}, this);
		},

		destroy: function(){
			if(this._animation){
				this._animation.stop();
			}
			dojo.forEach(this.getChildren(), function(child){
				// If AccordionContainer has been started, then each child has a wrapper widget which
				// also needs to be destroyed.
				if(child._wrapperWidget){
					child._wrapperWidget.destroy();
				}else{
					child.destroyRecursive();
				}
			});
			this.inherited(arguments);
		},

		_showChild: function(child){
			// Override StackContainer._showChild() to set visibility of _wrapperWidget.containerNode
			child._wrapperWidget.containerNode.style.display="block";
			return this.inherited(arguments);
		},

		_hideChild: function(child){
			// Override StackContainer._showChild() to set visibility of _wrapperWidget.containerNode
			child._wrapperWidget.containerNode.style.display="none";
			this.inherited(arguments);
		},

		_transition: function(/*dijit._Widget?*/ newWidget, /*dijit._Widget?*/ oldWidget, /*Boolean*/ animate){
			// Overrides StackContainer._transition() to provide sliding of title bars etc.

			if(dojo.isIE < 8){
				// workaround animation bugs by not animating; not worth supporting animation for IE6 & 7
				animate = false;
			}

			if(this._animation){
				// there's an in-progress animation.  speedily end it so we can do the newly requested one
				this._animation.stop(true);
				delete this._animation;
			}

			var self = this;

			if(newWidget){
				newWidget._wrapperWidget.set("selected", true);

				var d = this._showChild(newWidget);	// prepare widget to be slid in

				// Size the new widget, in case this is the first time it's being shown,
				// or I have been resized since the last time it was shown.
				// Note that page must be visible for resizing to work.
				if(this.doLayout && newWidget.resize){
					newWidget.resize(this._containerContentBox);
				}
			}

			if(oldWidget){
				oldWidget._wrapperWidget.set("selected", false);
				if(!animate){
					this._hideChild(oldWidget);
				}
			}

			if(animate){
				var newContents = newWidget._wrapperWidget.containerNode,
					oldContents = oldWidget._wrapperWidget.containerNode;

				// During the animation we will be showing two dijitAccordionChildWrapper nodes at once,
				// which on claro takes up 4px extra space (compared to stable AccordionContainer).
				// Have to compensate for that by immediately shrinking the pane being closed.
				var wrapperContainerNode = newWidget._wrapperWidget.containerNode,
					wrapperContainerNodeMargin = dojo._getMarginExtents(wrapperContainerNode),
					wrapperContainerNodePadBorder = dojo._getPadBorderExtents(wrapperContainerNode),
					animationHeightOverhead = wrapperContainerNodeMargin.h + wrapperContainerNodePadBorder.h;

				oldContents.style.height = (self._verticalSpace - animationHeightOverhead) + "px";

				this._animation = new dojo.Animation({
					node: newContents,
					duration: this.duration,
					curve: [1, this._verticalSpace - animationHeightOverhead - 1],
					onAnimate: function(value){
						value = Math.floor(value);	// avoid fractional values
						newContents.style.height = value + "px";
						oldContents.style.height = (self._verticalSpace - animationHeightOverhead - value) + "px";
					},
					onEnd: function(){
						delete self._animation;
						newContents.style.height = "auto";
						oldWidget._wrapperWidget.containerNode.style.display = "none";
						oldContents.style.height = "auto";
						self._hideChild(oldWidget);
					}
				});
				this._animation.onStop = this._animation.onEnd;
				this._animation.play();
			}

			return d;	// If child has an href, promise that fires when the widget has finished loading
		},

		// note: we are treating the container as controller here
		_onKeyPress: function(/*Event*/ e, /*dijit._Widget*/ fromTitle){
			// summary:
			//		Handle keypress events
			// description:
			//		This is called from a handler on AccordionContainer.domNode
			//		(setup in StackContainer), and is also called directly from
			//		the click handler for accordion labels
			if(this.disabled || e.altKey || !(fromTitle || e.ctrlKey)){
				return;
			}
			var k = dojo.keys,
				c = e.charOrCode;
			if((fromTitle && (c == k.LEFT_ARROW || c == k.UP_ARROW)) ||
					(e.ctrlKey && c == k.PAGE_UP)){
				this._adjacent(false)._buttonWidget._onTitleClick();
				dojo.stopEvent(e);
			}else if((fromTitle && (c == k.RIGHT_ARROW || c == k.DOWN_ARROW)) ||
					(e.ctrlKey && (c == k.PAGE_DOWN || c == k.TAB))){
				this._adjacent(true)._buttonWidget._onTitleClick();
				dojo.stopEvent(e);
			}
		}
	}
);

dojo.declare("dijit.layout._AccordionInnerContainer",
	[dijit._Widget, dijit._CssStateMixin], {
		// summary:
		//		Internal widget placed as direct child of AccordionContainer.containerNode.
		//		When other widgets are added as children to an AccordionContainer they are wrapped in
		//		this widget.
		
/*=====
		// buttonWidget: String
		//		Name of class to use to instantiate title
		//		(Wish we didn't have a separate widget for just the title but maintaining it
		//		for backwards compatibility, is it worth it?)
		 buttonWidget: null,
=====*/

/*=====
		// contentWidget: dijit._Widget
		//		Pointer to the real child widget
	 	contentWidget: null,
=====*/

		baseClass: "dijitAccordionInnerContainer",

		// tell nested layout widget that we will take care of sizing
		isContainer: true,
		isLayoutContainer: true,

		buildRendering: function(){
			// Builds a template like:
			//	<div class=dijitAccordionInnerContainer>
			//		Button
			//		<div class=dijitAccordionChildWrapper>
			//			ContentPane
			//		</div>
			//	</div>

			// Create wrapper div, placed where the child is now
			this.domNode = dojo.place("<div class='" + this.baseClass + "'>", this.contentWidget.domNode, "after");
			
			// wrapper div's first child is the button widget (ie, the title bar)
			var child = this.contentWidget,
				cls = dojo.getObject(this.buttonWidget);
			this.button = child._buttonWidget = (new cls({
				contentWidget: child,
				label: child.title,
				title: child.tooltip,
				dir: child.dir,
				lang: child.lang,
				iconClass: child.iconClass,
				id: child.id + "_button",
				parent: this.parent
			})).placeAt(this.domNode);
			
			// and then the actual content widget (changing it from prior-sibling to last-child),
			// wrapped by a <div class=dijitAccordionChildWrapper>
			this.containerNode = dojo.place("<div class='dijitAccordionChildWrapper' style='display:none'>", this.domNode);
			dojo.place(this.contentWidget.domNode, this.containerNode);
		},

		postCreate: function(){
			this.inherited(arguments);

			// Map changes in content widget's title etc. to changes in the button
			var button = this.button;
			this._contentWidgetWatches = [
				this.contentWidget.watch('title', dojo.hitch(this, function(name, oldValue, newValue){
					button.set("label", newValue);
				})),
				this.contentWidget.watch('tooltip', dojo.hitch(this, function(name, oldValue, newValue){
					button.set("title", newValue);
				})),
				this.contentWidget.watch('iconClass', dojo.hitch(this, function(name, oldValue, newValue){
					button.set("iconClass", newValue);
				}))
			];
		},

		_setSelectedAttr: function(/*Boolean*/ isSelected){
			this._set("selected", isSelected);
			this.button.set("selected", isSelected);
			if(isSelected){
				var cw = this.contentWidget;
				if(cw.onSelected){ cw.onSelected(); }
			}
		},

		startup: function(){
			// Called by _Container.addChild()
			this.contentWidget.startup();
		},

		destroy: function(){
			this.button.destroyRecursive();

			dojo.forEach(this._contentWidgetWatches || [], function(w){ w.unwatch(); });

			delete this.contentWidget._buttonWidget;
			delete this.contentWidget._wrapperWidget;

			this.inherited(arguments);
		},
		
		destroyDescendants: function(){
			// since getChildren isn't working for me, have to code this manually
			this.contentWidget.destroyRecursive();
		}
});

dojo.declare("dijit.layout._AccordionButton",
	[dijit._Widget, dijit._Templated, dijit._CssStateMixin],
	{
	// summary:
	//		The title bar to click to open up an accordion pane.
	//		Internal widget used by AccordionContainer.
	// tags:
	//		private

	templateString: dojo.cache("dijit.layout", "templates/AccordionButton.html", "<div dojoAttachEvent='onclick:_onTitleClick' class='dijitAccordionTitle'>\n\t<div dojoAttachPoint='titleNode,focusNode' dojoAttachEvent='onkeypress:_onTitleKeyPress'\n\t\t\tclass='dijitAccordionTitleFocus' role=\"tab\" aria-expanded=\"false\"\n\t\t><span class='dijitInline dijitAccordionArrow' role=\"presentation\"></span\n\t\t><span class='arrowTextUp' role=\"presentation\">+</span\n\t\t><span class='arrowTextDown' role=\"presentation\">-</span\n\t\t><img src=\"${_blankGif}\" alt=\"\" class=\"dijitIcon\" dojoAttachPoint='iconNode' style=\"vertical-align: middle\" role=\"presentation\"/>\n\t\t<span role=\"presentation\" dojoAttachPoint='titleTextNode' class='dijitAccordionText'></span>\n\t</div>\n</div>\n"),
	attributeMap: dojo.mixin(dojo.clone(dijit.layout.ContentPane.prototype.attributeMap), {
		label: {node: "titleTextNode", type: "innerHTML" },
		title: {node: "titleTextNode", type: "attribute", attribute: "title"},
		iconClass: { node: "iconNode", type: "class" }
	}),

	baseClass: "dijitAccordionTitle",

	getParent: function(){
		// summary:
		//		Returns the AccordionContainer parent.
		// tags:
		//		private
		return this.parent;
	},

	buildRendering: function(){
		this.inherited(arguments);
		var titleTextNodeId = this.id.replace(' ','_');
		dojo.attr(this.titleTextNode, "id", titleTextNodeId+"_title");
		dijit.setWaiState(this.focusNode, "labelledby", dojo.attr(this.titleTextNode, "id"));
		dojo.setSelectable(this.domNode, false);
	},

	getTitleHeight: function(){
		// summary:
		//		Returns the height of the title dom node.
		return dojo._getMarginSize(this.domNode).h;	// Integer
	},

	// TODO: maybe the parent should set these methods directly rather than forcing the code
	// into the button widget?
	_onTitleClick: function(){
		// summary:
		//		Callback when someone clicks my title.
		var parent = this.getParent();
			parent.selectChild(this.contentWidget, true);
			dijit.focus(this.focusNode);
	},

	_onTitleKeyPress: function(/*Event*/ evt){
		return this.getParent()._onKeyPress(evt, this.contentWidget);
	},

	_setSelectedAttr: function(/*Boolean*/ isSelected){
		this._set("selected", isSelected);
		dijit.setWaiState(this.focusNode, "expanded", isSelected);
		dijit.setWaiState(this.focusNode, "selected", isSelected);
		this.focusNode.setAttribute("tabIndex", isSelected ? "0" : "-1");
	}
});

}

if(!dojo._hasResource['epages.cartridges.de_epages.presentation.visualaidcontroller']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.presentation.visualaidcontroller'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.visualaidcontroller $Revision: 1.8 $

*/
dojo.provide('epages.cartridges.de_epages.presentation.visualaidcontroller');

epages.cartridges.de_epages.presentation.visualaidcontroller = {
	isVisualAidVisible: true,
	visualAidClassNames: ["HideVisualAid", "ShowVisualAid"],
	win: window,

	toggleVisualAid: function() {
		this.isVisualAidVisible = !this.isVisualAidVisible;
		this.setVisualAid(this.isVisualAidVisible);
	},
	getVisualAidClassName: function () {
		return this.visualAidClassNames[this.isVisualAidVisible ? 1 : 0];
	},
	setVisualAid: function(isVisible) {
		var a = this.visualAidClassNames[isVisible ? 1 : 0];
		var r = this.visualAidClassNames[isVisible ? 0 : 1];
		if(this.win.tinyMCE){
			for (var e in this.win.tinyMCE.instances) {
				iDoc=$E(this.win.tinyMCE.instances[e].iframeElement).getIframeDocument();
				dojo.addClass(iDoc.body,a);
				dojo.removeClass(iDoc.body,r);
			}
		}
		dojo.addClass(this.win.document.body,a);
		dojo.removeClass(this.win.document.body,r);
		this.isVisualAidVisible=isVisible;
		dojo.publish('presentation/setVisualAid', [{
			isVisible: this.isVisualAidVisible
		}]);
	}
};

dojo.subscribe("EmbeddedStorefront/onLoad", function(iframe) {
	epages.cartridges.de_epages.presentation.visualaidcontroller.win = iframe.contentWindow;
	epages.cartridges.de_epages.presentation.visualaidcontroller.setVisualAid(epages.cartridges.de_epages.presentation.visualaidcontroller.isVisualAidVisible);
});

dojo.subscribe("EmbeddedStorefront/onChange", function(iframe) {
	epages.cartridges.de_epages.presentation.visualaidcontroller.win = iframe.contentWindow;
	epages.cartridges.de_epages.presentation.visualaidcontroller.setVisualAid(epages.cartridges.de_epages.presentation.visualaidcontroller.isVisualAidVisible);
});

}

if(!dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Undobuttons"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Undobuttons"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.
*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.Undobuttons");




dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.Undobuttons",
	[	epages.widget.LocalizedWidget ],
	{
		undoObject      : undefined,
		updateObject    : undefined,
		templateString:"<form>\n<div class=\"UndoButtons\">\n  <button type=\"button\" class=\"FloatLeft Button SaveButton Disabled\"  dojoAttachPoint=\"savebutton\">{Save}</button>\n  <div class=\"CommandMedium UndoIcon DisabledButton\" dojoAttachPoint=\"undobutton\">\n     <i class=\"Sprite ico_m_undo\" title=\"{Undo}\"></i>\n  </div>\n  <div class=\"CommandMedium RedoIcon DisabledButton\" dojoAttachPoint=\"redobutton\">\n    <i class=\"Sprite ico_m_redo\" title=\"{Redo}\"></i>\n  </div>\n</div>\n</form>\n",
		imagePath       : epages.themeUrl('images'),
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', 'templates/translation'),
		containerId     : "",
		validate        : null,
		siteId          : epages.vars.SiteID || '',
		url             : '?',
		isWizard        : false,

		postMixInProperties: function() {
			if ($$(this.id)) {
				// a widget with this id already exists
				var newId = '';
				var counter = 0;
				do {
					newId = this.id + '_' + counter;
				} while ($$(newId));
				this.id = newId;
			}
		},

		getUndoObject: function () {
			return this.undoObject;
		},

		postCreate: function() {
			if(this.containerId != "" && $(this.containerId) ){
				this.undoObject = new epages.html.UnDo($(this.containerId));
			}else{
				this.undoObject = new epages.html.UnDo();
			}
			dojo.addOnLoad(this, "init");
			this.inherited("postCreate", arguments);
		},

		init: function() {
			this.connect(this.undoObject, "validateInput", "toggleButtons");

			this.connect(this.undoObject, "undo", "toggleButtons");
			dojo.connect(this.undobutton, "onclick", this.undoObject, "undo");

			this.connect(this.undoObject, "redo", "toggleButtons");
			dojo.connect(this.redobutton, "onclick", this.undoObject, "redo");

			this.connect(this.savebutton, "onclick", "sendChanges");
			this.connect(this.savebutton, "onclick", "toggleButtons");

			this.connect(this.undoObject, "onChangeTyping", "toggleButtons");
		},

		toggleButtons: function(evt) {
			if (this.undoObject.historyStack.length != 0) {
				dojo.removeClass(this.undobutton, "DisabledButton");
			} else {
				dojo.addClass(this.undobutton, "DisabledButton");
			}
			if (this.undoObject.forwardStack.length != 0) {
				dojo.removeClass(this.redobutton, "DisabledButton");
			} else {
				dojo.addClass(this.redobutton, "DisabledButton");
			}
			if (this.undoObject.errorStack.length == 0 && (
						this.undoObject.isTyping ||
						this.undoObject.existsChanges()
					)
			) {
				dojo.removeClass(this.savebutton, "Disabled");
			} else {
				dojo.addClass(this.savebutton, "Disabled");
			}
		},

		sendChanges: function(messageOpt) {
			var message = this.translate("BusyWhileSavingData");
			var permanentMessage = false;
			if(messageOpt) {
				if(messageOpt.text){ message = messageOpt.text; }
				if(messageOpt.permanent){ permanentMessage = true; }
			}
			if (this.undoObject.errorStack.length == 0 && this.existsChanges()) {
				dojo.publish("uimessage/startBusy", ["Undobuttons", message ]);
				if (this.updateObject === undefined) {
					
					this.updateObject = new epages.cartridges.de_epages.presentation.ObjectUpdater({siteId:this.siteId});
				}
				this.updateObject.sendAsync(this.url, this.updateObject.getFormDataViaObjectForm(this.undoObject.getChanged()), function() {
					// dojo.publish("uimessage/stopBusy", ["Undobuttons"]);
					if(permanentMessage != true){
						window.setTimeout(function() {dojo.publish('uimessage/stopBusy', ["Undobuttons"]);} , 500);
					}
					dojo.publish('undobuttons/saveFinished', []);
				},this.isWizard);
				this.undoObject.checkTyping(false);
				this.undoObject.clear();
				this.toggleButtons();
			}// else  alert("errors: " + this.undoObject.errorStack.length);
		},

		existsChanges: function(){
			return this.undoObject.existsChanges();
		}
	}
);

epages.onUnloadFunctions.push(function() {
	var w = $$("undoWidget");
	if(w){
		return w.existsChanges();
	}
	return false;
});

}

if(!dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Toolvisualaid"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Toolvisualaid"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.Toolfont $Revision: 1.9 $

*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.Toolvisualaid");




dojo.declare("epages.cartridges.de_epages.presentation.widget.Toolvisualaid",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * private properties
		 */
		_classes      : ['ico_s_visualaid','ico_s_visualaid_hidden'],
		/**
		 * widget properties
		 */
		templateString:"<div class=\"CommandSmallWithLink VisualAid TopMargin NoPadding\" title=\"{ToggleGuideLines}\" /><i dojoAttachPoint=\"iconNode\" class=\"Sprite ico_s_visualaid\"></i>{GuideLines}</div>\n",
		imagePath    : epages.themeUrl('images'),
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', 'templates/translation'),

		postCreate  : function() {
			this.inherited("postCreate", arguments);
			this.connect(this.domNode, "onclick", '_setVisualAid');
			dojo.subscribe('presentation/setVisualAid', this, '_updateButton');  // multiple instances of this widget can react on a change
		},

		_setVisualAid: function() {
			epages.cartridges.de_epages.presentation.visualaidcontroller.toggleVisualAid();
		},

		_updateButton: function(opt) {
			epages.html.replaceClass(this.iconNode, this._classes[opt.isVisible ? 0 : 1], this._classes[opt.isVisible ? 1 : 0]);
		}
});

}

if(!dojo._hasResource['epages.html.form']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.html.form'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.html.element $Revision: 1.12 $

*/
dojo.provide('epages.html.form');



epages.html.Form = function (object) {
	if (object === undefined) {
		console.warn('epages.html.Form: initialize without object.');
		// raise error for callback
		var name = object.className;
	}
	this.object = object;
};

dojo.extend(epages.html.Form, {
	object: undefined,

	get: function () {
		var content = $H();
		for( var i=0,iLength=this.object.elements.length ; i<iLength ; i++ ){
			var elm = this.object.elements[i];
			if (elm.getAttribute('ep_form') != 'false') {
				var name = elm.name;
				var value = content.get(name);
				if (value === undefined){
					value = [];
				}
				value.push($E(elm).get());
				content.set(name, value);
			}
		}
		return content;
	},

	set: function (content,callOnChange) {
		if(callOnChange === undefined){
			callOnChange = true;
		}
		if (dojo.isString(content)){
			content = $H(dojo.fromJson(content));
		}

		for( var i=0,iLength=this.object.elements.length ; i<iLength ; i++ ){
			var elm = this.object.elements[i];
			var name = elm.name;
			var value = content.get(name);
			if(value != '' && value != undefined && elm.getAttribute('widgetid') && (dojo.hasClass(elm,'Radio') || dojo.hasClass(elm,'Checkbox'))){
				$$(elm.getAttribute('widgetid')).setChecked(true);
			}
			if (value !== undefined) {
				var hlm = $E(elm);
				hlm.set(value.shift());
				if(callOnChange){
					hlm.callOnChange();
				}
				content.set(name, value);
			}
		}
	},

	toString: function() {
		return this.get().toString();
	}

});

}

if(!dojo._hasResource['epages.widget.Slider']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.widget.Slider'] = true;
/*
	Copyright (c) 2006-2008, ePages GmbH
	All Rights Reserved.

	epages.widget.Slider $Revision: 1.12 $

*/
dojo.provide('epages.widget.Slider');



dojo.declare("epages.widget.Slider", [dijit._Widget,dijit._Templated], {
	timerLeft         : null,
	timerRight        : null,
	slideSpeed        : 0,
	currentWidth      : 0,   // Integer - total width of the container that holds all images
	menuWidth         : 0,   // Integer - width of the visible part of the slider
	currentMoveState  : '',  // String - current State of Animation, left, right or empty
	maxSpeed          : 15,  // Integer - max Speed of Animation on the End of the Slider increase to speed up Slider
	totalOffsetLeft   : 0,   // Integer - total Offset of the Slider to the left side of the browser

	templateString:"<div class=\"ImageSlide\">\n  <div dojoAttachPoint=\"crossSlide\"><nobr dojoAttachPoint=\"containerNode\"></nobr></div>\n</div>\n",

	postCreate: function() {
		this.inherited("postCreate", arguments);
		// summary: standard init routine
		// description: Link needed events to appropriate functions
		// 		and set all global variables needed in other functions.
		//		Also hide the horizontal fallback scrollbar and revise
		//		the height of the main element.
		//
		//		An Image Slide frame must look like this:
		//		...and YES, every char has a purpose!
		//		E. g. to ensure a fallback alternative for
		//		people without javascript.
		//		for a detailed example look at the SliderTest.html
		// example:
		//	|	<div dojoType="epages.widget.Slider" maxSpeed="50" class="ImageSlide">
		//	|		<nobr style="width:50px"> //total Width of Container width of picture * number of pictures
		//	|		      <a href="#go">
		//	|		        <img src="pic1.gif"/>
		//	|		      </a>
		//	|		      <a href="#go">
		//	|		        <img src="pic2.gif"/>
		//	|		      </a>
		//	|		      <a href="#go">
		//	|		        <img src="pic3.gif"/>
		//	|		      </a>
		//	|					...
		//	|		    </nobr>
		//	|	</div>
		this.connect(window, 'onresize', '_arrangeResizedDocument');
		this.domNode.style.overflow = 'hidden';
		this.domNode.style.height = this.crossSlide.offsetHeight+'px';
		this.menuWidth = this.domNode.offsetWidth;
		var crossSlideWidth = (this.crossSlide.style.width != "") ? parseInt(this.crossSlide.style.width) : 0;
		this.currentWidth = this.crossSlide.offsetWidth? this.crossSlide.offsetWidth : crossSlideWidth;
		this.crossSlide.style.left = 0;
		this.totalOffsetLeft = this.domNode.offsetLeft;
		this._appendEvents();
	},

	_appendEvents: function() {
		this.connect(this.domNode,'onmousemove', '_doMotion');
		this.connect(this.domNode,'onmouseout', '_stopMotion');
	},

	_updateAfterEvent: function() {
		// summary: update the image slide line
		// description: We must force the css engine of some browsers
		//    to refresh the style on the whole image slide.
		//    Otherwise the styles will not be updated and e. g.
		//    the :hover class misfires for all prior invisible images.
		// example:
		//  |  _updateAfterEvent();
		this.domNode.style.clear = 'both';
		this.domNode.style.clear = 'none';
	},

	_moveLeft: function() {
		// summary: move the image line inside the container to the left
		// description: First we check if it is necessary to move the
		//		image line and if "yes" we move it as long the cursor indicates
		//    that it should move. To not confuse other functions we state
		//		that we are currently really moving it to the left. MOVE!
		// example:
		//  | _moveLeft();
		this.currentMoveState = 'left';
		if(parseInt(this.crossSlide.style.left) > (this.menuWidth - this.currentWidth)){
			this.crossSlide.style.left = parseInt(this.crossSlide.style.left) - this.slideSpeed + 'px';
		}
		this.timerLeft = setTimeout(epages.lang.hitch(this, this._moveLeft), 10);
	},

	_moveRight: function(){
		// summary: move the image line inside the container to the rights
		// description: First we check if it is necessary to move the
		//		image line and if "yes" we move it as long the cursor indicates
		//    that it should move. To not confuse other functions we state
		//		that we are currently really moving it to the right. MOVE!
		// example:
		//  | _moveRight();
		this.currentMoveState = 'right';
		if(parseInt(this.crossSlide.style.left) < 0){
			this.crossSlide.style.left = parseInt(this.crossSlide.style.left) + this.slideSpeed + 'px';
		}
		this.timerRight = setTimeout(epages.lang.hitch(this, this._moveRight), 10);
	},

	_doMotion: function(/*Object?*/ mouseEvent){
		// summary: the heart of our sliding effect
		// description: It does all the stuff like calculating the speed of
		//		the image slide, observing the cursor for new motions and
		//		initiating the move[...]() functions.
		// example:
		//  | mynode.onmousemove = function(mouseEvent){
		//  |   _doMotion(mouseEvent);
		//  |   _updateAfterEvent();
		//  | }
		var mouseXPoint = mouseEvent.clientX;
		var currentYPosition = mouseEvent.clientX - this.totalOffsetLeft;
		var edgeBound = (this.menuWidth / 2);
		if (currentYPosition > edgeBound){
			this.slideSpeed = (currentYPosition - edgeBound) / this.menuWidth / 2 * this.maxSpeed;
			clearTimeout(this.timerRight);
			if (this.currentMoveState != 'left'){
				this._moveLeft();
			}
		} else if (currentYPosition < edgeBound){
			this.slideSpeed = (edgeBound - currentYPosition) / this.menuWidth / 2 * this.maxSpeed;;
			clearTimeout(this.timerLeft);
			if (this.currentMoveState != 'right'){
			this._moveRight();
			}
		}else{
			this.slideSpeed = 0;
		}
	},

	_stopMotion: function(/*Object?*/ mouseEvent){
		// summary: stops all slide motions
		// description: If called with a mouse position where the slide
		//    should be stopped - we have to immediately clear all
		//		active timeouts that would call the move[...] functions.
		//		Furthermore we state that there is no motion active anymore.
		// example:
		//  | mynode.onmouseout = function(mouseEvent){
		//  |   _stopMotion(mouseEvent);
		//  |   _updateAfterEvent();
		//  | }
		if ((window.event && !this.domNode.contains(event.toElement)) || (mouseEvent && mouseEvent.currentTarget && mouseEvent.currentTarget!= mouseEvent.relatedTarget && !this._checkNode(mouseEvent.currentTarget, mouseEvent.relatedTarget))){
			clearTimeout(this.timerLeft);
			clearTimeout(this.timerRight);
			this.currentMoveState = "";
		}
	},

	_checkNode: function(/*Object?*/ currentTarget, /*Object?*/ relatedTarget) {
		// summary: check if we are in the right element
		// description: Naturally there is one browser that behaves unintentional.
		//		This time nearly all browsers fail. Without this routine
		//		Firefox would refer the mousemove event to every single image
		//		(the motion would only start if the cursor points an image).
		//		Netscape would inherit the mousemove event to the whole
		//		document body and the Internet Explorer would produce sensless
		//		error messages because it does not know the attribute.
		// example:
		//  |  var canIPleaseKillTheTimout = _checkNode(currentTarget, relatedTarget);
		if (relatedTarget !== null){
			while (relatedTarget.parentNode){
				relatedTarget = relatedTarget.parentNode;
				if (relatedTarget == currentTarget){
					return true; // Boolean
				}
			}
		}
	},

	_arrangeResizedDocument: function() {
		// summary: adjust the whole thing on window resizing
		// description: We have to resize and realign the slide
		//		if the size of the browser window changes.
		// example:
		//  | window.onresize = _arrangeResizedDocument;
		this.menuWidth = this.domNode.offsetWidth;
		this.crossSlide.style.left = this.menuWidth - this.currentWidth + 'px';
	}
});

}


dojo.i18n._preloadLocalizations("epages.nls.ep_shop_preview", ["ROOT","ca","da","de","en","es","fi","fr","it","nl","no","pt","ro","ru","sv","xx"]);
