/*globals define*/

define([
    'testsuite/qunit',
    'jquery',
    './tray',
    '$ready!'
], function (QUnit, $, Tray) {
    'use strict';

    var fixture = $('#qunit-fixture'),
        options = {
            tabs: {
                'products': {
                    id: 'view1',
                    name: 'products',
                    additionalContent: '<input type="checkbox" name="checkboxAdditionalContent" />',
                    action: 'JSONInsertFromProducts'
                }
            }
        },
        tray;

    QUnit.module("de_epages/presentation/tray", {
        setup: function () {
            tray = new Tray(options);
            tray.open();
        },
        teardown: function () {
            tray.destroy();
        }
    });

    QUnit.test('Check tray\'s public methods', function () {
        $.each(['open', 'close'], function () {
            QUnit.ok(
                $.isFunction(tray[this]),
                'Check if ' + this + ' is a method of the tray'
            );
        });
    });

    QUnit.test('Check dialog handling', function () {
        QUnit.ok(
            $('.ui-dialog').length === 1,
            'Check if dialog is created'
        );

        tray.close();
        QUnit.ok(
            $('.ui-dialog:visible').length === 0,
            'Check if dialog is closed'
        );

        tray.destroy();
        QUnit.ok(
            $('.ui-dialog').length === 0,
            'Check if dialog is destroyed'
        );
    });
});